/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"

#if _WIN32
#pragma warning(push,1)
#pragma warning(disable:4702) // unreachable code
#endif
#line 161 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"


// some helpers
#include <float.h> // for FLT_MAX

static CSphFilterSettings * AddMvaRange ( SqlParser_c * pParser, const SqlNode_t & tNode, int64_t iMin, int64_t iMax )
{
	CSphFilterSettings * f = pParser->AddFilter ( tNode, SPH_FILTER_RANGE );
	f->m_eMvaFunc = ( tNode.m_iType==TOK_ALL ) ? SPH_MVAFUNC_ALL : SPH_MVAFUNC_ANY;
	f->m_iMinValue = iMin;
	f->m_iMaxValue = iMax;
	return f;
}

#define TRACK_BOUNDS(_res,_left,_right) \
	_res = _left; \
	if ( _res.m_iStart>0 && pParser->m_pBuf[_res.m_iStart-1]=='`' ) \
		_res.m_iStart--; \
	_res.m_iEnd = _right.m_iEnd; \
	_res.m_iType = 0;


#line 100 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "bissphinxql.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOK_IDENT = 3,                  /* "identifier"  */
  YYSYMBOL_TOK_BACKIDENT = 4,              /* "`identifier`"  */
  YYSYMBOL_TOK_ATIDENT = 5,                /* TOK_ATIDENT  */
  YYSYMBOL_TOK_CONST_INT = 6,              /* "integer"  */
  YYSYMBOL_TOK_CONST_FLOAT = 7,            /* "float"  */
  YYSYMBOL_TOK_CONST_MVA = 8,              /* TOK_CONST_MVA  */
  YYSYMBOL_TOK_QUOTED_STRING = 9,          /* "string"  */
  YYSYMBOL_TOK_USERVAR = 10,               /* "@uservar"  */
  YYSYMBOL_TOK_SYSVAR = 11,                /* "@@sysvar"  */
  YYSYMBOL_TOK_CONST_STRINGS = 12,         /* TOK_CONST_STRINGS  */
  YYSYMBOL_TOK_BAD_NUMERIC = 13,           /* TOK_BAD_NUMERIC  */
  YYSYMBOL_TOK_SUBKEY = 14,                /* TOK_SUBKEY  */
  YYSYMBOL_TOK_BACKTICKED_SUBKEY = 15,     /* TOK_BACKTICKED_SUBKEY  */
  YYSYMBOL_TOK_DOT_NUMBER = 16,            /* ".number"  */
  YYSYMBOL_TOK_AGENT = 17,                 /* TOK_AGENT  */
  YYSYMBOL_TOK_ALL = 18,                   /* TOK_ALL  */
  YYSYMBOL_TOK_ANY = 19,                   /* TOK_ANY  */
  YYSYMBOL_TOK_AS = 20,                    /* TOK_AS  */
  YYSYMBOL_TOK_ASC = 21,                   /* TOK_ASC  */
  YYSYMBOL_TOK_ATTACH = 22,                /* TOK_ATTACH  */
  YYSYMBOL_TOK_ATTRIBUTES = 23,            /* TOK_ATTRIBUTES  */
  YYSYMBOL_TOK_AVG = 24,                   /* TOK_AVG  */
  YYSYMBOL_TOK_BEGIN = 25,                 /* TOK_BEGIN  */
  YYSYMBOL_TOK_BETWEEN = 26,               /* TOK_BETWEEN  */
  YYSYMBOL_TOK_BIGINT = 27,                /* TOK_BIGINT  */
  YYSYMBOL_TOK_BY = 28,                    /* TOK_BY  */
  YYSYMBOL_TOK_CALL = 29,                  /* TOK_CALL  */
  YYSYMBOL_TOK_CHARACTER = 30,             /* TOK_CHARACTER  */
  YYSYMBOL_TOK_CHUNK = 31,                 /* TOK_CHUNK  */
  YYSYMBOL_TOK_CLUSTER = 32,               /* TOK_CLUSTER  */
  YYSYMBOL_TOK_COLLATE = 33,               /* TOK_COLLATE  */
  YYSYMBOL_TOK_COLLATION = 34,             /* TOK_COLLATION  */
  YYSYMBOL_TOK_COLUMN = 35,                /* TOK_COLUMN  */
  YYSYMBOL_TOK_COMMIT = 36,                /* TOK_COMMIT  */
  YYSYMBOL_TOK_COMMITTED = 37,             /* TOK_COMMITTED  */
  YYSYMBOL_TOK_COUNT = 38,                 /* TOK_COUNT  */
  YYSYMBOL_TOK_CREATE = 39,                /* TOK_CREATE  */
  YYSYMBOL_TOK_DATABASES = 40,             /* TOK_DATABASES  */
  YYSYMBOL_TOK_DEBUGCLAUSE = 41,           /* TOK_DEBUGCLAUSE  */
  YYSYMBOL_TOK_DELETE = 42,                /* TOK_DELETE  */
  YYSYMBOL_TOK_DESC = 43,                  /* TOK_DESC  */
  YYSYMBOL_TOK_DESCRIBE = 44,              /* TOK_DESCRIBE  */
  YYSYMBOL_TOK_DISTINCT = 45,              /* TOK_DISTINCT  */
  YYSYMBOL_TOK_DIV = 46,                   /* TOK_DIV  */
  YYSYMBOL_TOK_DOUBLE = 47,                /* TOK_DOUBLE  */
  YYSYMBOL_TOK_EXPLAIN = 48,               /* TOK_EXPLAIN  */
  YYSYMBOL_TOK_FACET = 49,                 /* TOK_FACET  */
  YYSYMBOL_TOK_FALSE = 50,                 /* TOK_FALSE  */
  YYSYMBOL_TOK_FLOAT = 51,                 /* TOK_FLOAT  */
  YYSYMBOL_TOK_FLUSH = 52,                 /* TOK_FLUSH  */
  YYSYMBOL_TOK_FOR = 53,                   /* TOK_FOR  */
  YYSYMBOL_TOK_FORCE = 54,                 /* TOK_FORCE  */
  YYSYMBOL_TOK_FROM = 55,                  /* TOK_FROM  */
  YYSYMBOL_TOK_GLOBAL = 56,                /* TOK_GLOBAL  */
  YYSYMBOL_TOK_GROUP = 57,                 /* TOK_GROUP  */
  YYSYMBOL_TOK_GROUPBY = 58,               /* TOK_GROUPBY  */
  YYSYMBOL_TOK_GROUP_CONCAT = 59,          /* TOK_GROUP_CONCAT  */
  YYSYMBOL_TOK_HAVING = 60,                /* TOK_HAVING  */
  YYSYMBOL_TOK_HOSTNAMES = 61,             /* TOK_HOSTNAMES  */
  YYSYMBOL_TOK_IGNORE = 62,                /* TOK_IGNORE  */
  YYSYMBOL_TOK_IN = 63,                    /* TOK_IN  */
  YYSYMBOL_TOK_INDEX = 64,                 /* TOK_INDEX  */
  YYSYMBOL_TOK_INDEXES = 65,               /* TOK_INDEXES  */
  YYSYMBOL_TOK_INDEXOF = 66,               /* TOK_INDEXOF  */
  YYSYMBOL_TOK_INSERT = 67,                /* TOK_INSERT  */
  YYSYMBOL_TOK_INT = 68,                   /* TOK_INT  */
  YYSYMBOL_TOK_INTEGER = 69,               /* TOK_INTEGER  */
  YYSYMBOL_TOK_INTO = 70,                  /* TOK_INTO  */
  YYSYMBOL_TOK_IS = 71,                    /* TOK_IS  */
  YYSYMBOL_TOK_ISOLATION = 72,             /* TOK_ISOLATION  */
  YYSYMBOL_TOK_LEVEL = 73,                 /* TOK_LEVEL  */
  YYSYMBOL_TOK_LIKE = 74,                  /* TOK_LIKE  */
  YYSYMBOL_TOK_LIMIT = 75,                 /* TOK_LIMIT  */
  YYSYMBOL_TOK_LOGS = 76,                  /* TOK_LOGS  */
  YYSYMBOL_TOK_MATCH = 77,                 /* TOK_MATCH  */
  YYSYMBOL_TOK_MAX = 78,                   /* TOK_MAX  */
  YYSYMBOL_TOK_META = 79,                  /* TOK_META  */
  YYSYMBOL_TOK_MIN = 80,                   /* TOK_MIN  */
  YYSYMBOL_TOK_MOD = 81,                   /* TOK_MOD  */
  YYSYMBOL_TOK_MULTI = 82,                 /* TOK_MULTI  */
  YYSYMBOL_TOK_MULTI64 = 83,               /* TOK_MULTI64  */
  YYSYMBOL_TOK_NAMES = 84,                 /* TOK_NAMES  */
  YYSYMBOL_TOK_NOT = 85,                   /* TOK_NOT  */
  YYSYMBOL_TOK_NULL = 86,                  /* TOK_NULL  */
  YYSYMBOL_TOK_OFFSET = 87,                /* TOK_OFFSET  */
  YYSYMBOL_TOK_OPTION = 88,                /* TOK_OPTION  */
  YYSYMBOL_TOK_ORDER = 89,                 /* TOK_ORDER  */
  YYSYMBOL_TOK_OPTIMIZE = 90,              /* TOK_OPTIMIZE  */
  YYSYMBOL_TOK_PLAN = 91,                  /* TOK_PLAN  */
  YYSYMBOL_TOK_PLUGINS = 92,               /* TOK_PLUGINS  */
  YYSYMBOL_TOK_PROFILE = 93,               /* TOK_PROFILE  */
  YYSYMBOL_TOK_RAND = 94,                  /* TOK_RAND  */
  YYSYMBOL_TOK_RAMCHUNK = 95,              /* TOK_RAMCHUNK  */
  YYSYMBOL_TOK_READ = 96,                  /* TOK_READ  */
  YYSYMBOL_TOK_REGEX = 97,                 /* TOK_REGEX  */
  YYSYMBOL_TOK_RECONFIGURE = 98,           /* TOK_RECONFIGURE  */
  YYSYMBOL_TOK_RELOAD = 99,                /* TOK_RELOAD  */
  YYSYMBOL_TOK_REPEATABLE = 100,           /* TOK_REPEATABLE  */
  YYSYMBOL_TOK_REPLACE = 101,              /* TOK_REPLACE  */
  YYSYMBOL_TOK_REMAP = 102,                /* TOK_REMAP  */
  YYSYMBOL_TOK_ROLLBACK = 103,             /* TOK_ROLLBACK  */
  YYSYMBOL_TOK_RTINDEX = 104,              /* TOK_RTINDEX  */
  YYSYMBOL_TOK_SELECT = 105,               /* TOK_SELECT  */
  YYSYMBOL_TOK_SERIALIZABLE = 106,         /* TOK_SERIALIZABLE  */
  YYSYMBOL_TOK_SET = 107,                  /* TOK_SET  */
  YYSYMBOL_TOK_SETTINGS = 108,             /* TOK_SETTINGS  */
  YYSYMBOL_TOK_SESSION = 109,              /* TOK_SESSION  */
  YYSYMBOL_TOK_SHOW = 110,                 /* TOK_SHOW  */
  YYSYMBOL_TOK_SONAME = 111,               /* TOK_SONAME  */
  YYSYMBOL_TOK_START = 112,                /* TOK_START  */
  YYSYMBOL_TOK_STATUS = 113,               /* TOK_STATUS  */
  YYSYMBOL_TOK_STRING = 114,               /* TOK_STRING  */
  YYSYMBOL_TOK_SYSFILTERS = 115,           /* TOK_SYSFILTERS  */
  YYSYMBOL_TOK_SUM = 116,                  /* TOK_SUM  */
  YYSYMBOL_TOK_TABLE = 117,                /* TOK_TABLE  */
  YYSYMBOL_TOK_TABLES = 118,               /* TOK_TABLES  */
  YYSYMBOL_TOK_THREADS = 119,              /* TOK_THREADS  */
  YYSYMBOL_TOK_TO = 120,                   /* TOK_TO  */
  YYSYMBOL_TOK_TRANSACTION = 121,          /* TOK_TRANSACTION  */
  YYSYMBOL_TOK_TRUE = 122,                 /* TOK_TRUE  */
  YYSYMBOL_TOK_TRUNCATE = 123,             /* TOK_TRUNCATE  */
  YYSYMBOL_TOK_UNCOMMITTED = 124,          /* TOK_UNCOMMITTED  */
  YYSYMBOL_TOK_UPDATE = 125,               /* TOK_UPDATE  */
  YYSYMBOL_TOK_USE = 126,                  /* TOK_USE  */
  YYSYMBOL_TOK_VALUES = 127,               /* TOK_VALUES  */
  YYSYMBOL_TOK_VARIABLES = 128,            /* TOK_VARIABLES  */
  YYSYMBOL_TOK_WARNINGS = 129,             /* TOK_WARNINGS  */
  YYSYMBOL_TOK_WEIGHT = 130,               /* TOK_WEIGHT  */
  YYSYMBOL_TOK_WHERE = 131,                /* TOK_WHERE  */
  YYSYMBOL_TOK_WITH = 132,                 /* TOK_WITH  */
  YYSYMBOL_TOK_WITHIN = 133,               /* TOK_WITHIN  */
  YYSYMBOL_TOK_LTE = 134,                  /* "<="  */
  YYSYMBOL_TOK_GTE = 135,                  /* ">="  */
  YYSYMBOL_TOK_NE = 136,                   /* "!="  */
  YYSYMBOL_TOK_OR = 137,                   /* TOK_OR  */
  YYSYMBOL_TOK_AND = 138,                  /* TOK_AND  */
  YYSYMBOL_139_ = 139,                     /* '|'  */
  YYSYMBOL_140_ = 140,                     /* '&'  */
  YYSYMBOL_141_ = 141,                     /* '='  */
  YYSYMBOL_142_ = 142,                     /* '<'  */
  YYSYMBOL_143_ = 143,                     /* '>'  */
  YYSYMBOL_144_ = 144,                     /* '+'  */
  YYSYMBOL_145_ = 145,                     /* '-'  */
  YYSYMBOL_146_ = 146,                     /* '*'  */
  YYSYMBOL_147_ = 147,                     /* '/'  */
  YYSYMBOL_148_ = 148,                     /* '%'  */
  YYSYMBOL_TOK_NEG = 149,                  /* TOK_NEG  */
  YYSYMBOL_150_ = 150,                     /* ';'  */
  YYSYMBOL_151_ = 151,                     /* ':'  */
  YYSYMBOL_152_ = 152,                     /* ','  */
  YYSYMBOL_153_ = 153,                     /* '('  */
  YYSYMBOL_154_ = 154,                     /* ')'  */
  YYSYMBOL_155_ = 155,                     /* '{'  */
  YYSYMBOL_156_ = 156,                     /* '}'  */
  YYSYMBOL_157_ = 157,                     /* '['  */
  YYSYMBOL_158_ = 158,                     /* ']'  */
  YYSYMBOL_YYACCEPT = 159,                 /* $accept  */
  YYSYMBOL_request = 160,                  /* request  */
  YYSYMBOL_statement = 161,                /* statement  */
  YYSYMBOL_ident_set_no_option = 162,      /* ident_set_no_option  */
  YYSYMBOL_ident_set = 163,                /* ident_set  */
  YYSYMBOL_ident = 164,                    /* ident  */
  YYSYMBOL_ident_no_option = 165,          /* ident_no_option  */
  YYSYMBOL_identidx = 166,                 /* identidx  */
  YYSYMBOL_one_index = 167,                /* one_index  */
  YYSYMBOL_only_one_index = 168,           /* only_one_index  */
  YYSYMBOL_chunk_key = 169,                /* chunk_key  */
  YYSYMBOL_chunk_keys = 170,               /* chunk_keys  */
  YYSYMBOL_string_key = 171,               /* string_key  */
  YYSYMBOL_string_keys = 172,              /* string_keys  */
  YYSYMBOL_multi_strings_and_maybe_chunk_key = 173, /* multi_strings_and_maybe_chunk_key  */
  YYSYMBOL_multi_chunks_and_maybe_string_key = 174, /* multi_chunks_and_maybe_string_key  */
  YYSYMBOL_fromkeys = 175,                 /* fromkeys  */
  YYSYMBOL_one_index_opt_subindex = 176,   /* one_index_opt_subindex  */
  YYSYMBOL_one_index_opt_chunk = 177,      /* one_index_opt_chunk  */
  YYSYMBOL_from_target = 178,              /* from_target  */
  YYSYMBOL_list_of_indexes = 179,          /* list_of_indexes  */
  YYSYMBOL_string_nokeys = 180,            /* string_nokeys  */
  YYSYMBOL_multi_strings_and_maybe_chunk_nokey = 181, /* multi_strings_and_maybe_chunk_nokey  */
  YYSYMBOL_sysvar = 182,                   /* sysvar  */
  YYSYMBOL_sysvar_ext = 183,               /* sysvar_ext  */
  YYSYMBOL_multi_stmt_list = 184,          /* multi_stmt_list  */
  YYSYMBOL_multi_stmt = 185,               /* multi_stmt  */
  YYSYMBOL_select = 186,                   /* select  */
  YYSYMBOL_select1 = 187,                  /* select1  */
  YYSYMBOL_opt_tablefunc_args = 188,       /* opt_tablefunc_args  */
  YYSYMBOL_tablefunc_args_list = 189,      /* tablefunc_args_list  */
  YYSYMBOL_tablefunc_arg = 190,            /* tablefunc_arg  */
  YYSYMBOL_subselect_start = 191,          /* subselect_start  */
  YYSYMBOL_opt_outer_order = 192,          /* opt_outer_order  */
  YYSYMBOL_opt_outer_limit = 193,          /* opt_outer_limit  */
  YYSYMBOL_select_from = 194,              /* select_from  */
  YYSYMBOL_195_1 = 195,                    /* $@1  */
  YYSYMBOL_select_items_list = 196,        /* select_items_list  */
  YYSYMBOL_select_item = 197,              /* select_item  */
  YYSYMBOL_opt_alias = 198,                /* opt_alias  */
  YYSYMBOL_select_expr = 199,              /* select_expr  */
  YYSYMBOL_ident_list = 200,               /* ident_list  */
  YYSYMBOL_opt_where_clause = 201,         /* opt_where_clause  */
  YYSYMBOL_where_clause = 202,             /* where_clause  */
  YYSYMBOL_where_expr = 203,               /* where_expr  */
  YYSYMBOL_where_item = 204,               /* where_item  */
  YYSYMBOL_filter_expr = 205,              /* filter_expr  */
  YYSYMBOL_filter_item = 206,              /* filter_item  */
  YYSYMBOL_expr_ident = 207,               /* expr_ident  */
  YYSYMBOL_mva_aggr = 208,                 /* mva_aggr  */
  YYSYMBOL_const_int = 209,                /* const_int  */
  YYSYMBOL_const_float = 210,              /* const_float  */
  YYSYMBOL_const_float_unsigned = 211,     /* const_float_unsigned  */
  YYSYMBOL_const_list = 212,               /* const_list  */
  YYSYMBOL_string_list = 213,              /* string_list  */
  YYSYMBOL_opt_group_clause = 214,         /* opt_group_clause  */
  YYSYMBOL_opt_int = 215,                  /* opt_int  */
  YYSYMBOL_group_items_list = 216,         /* group_items_list  */
  YYSYMBOL_opt_having_clause = 217,        /* opt_having_clause  */
  YYSYMBOL_opt_group_order_clause = 218,   /* opt_group_order_clause  */
  YYSYMBOL_group_order_clause = 219,       /* group_order_clause  */
  YYSYMBOL_opt_order_clause = 220,         /* opt_order_clause  */
  YYSYMBOL_order_clause = 221,             /* order_clause  */
  YYSYMBOL_order_items_list = 222,         /* order_items_list  */
  YYSYMBOL_order_item = 223,               /* order_item  */
  YYSYMBOL_opt_limit_clause = 224,         /* opt_limit_clause  */
  YYSYMBOL_limit_clause = 225,             /* limit_clause  */
  YYSYMBOL_opt_option_clause = 226,        /* opt_option_clause  */
  YYSYMBOL_option_clause = 227,            /* option_clause  */
  YYSYMBOL_option_list = 228,              /* option_list  */
  YYSYMBOL_option_item = 229,              /* option_item  */
  YYSYMBOL_named_const_list = 230,         /* named_const_list  */
  YYSYMBOL_named_const = 231,              /* named_const  */
  YYSYMBOL_opt_hint_clause = 232,          /* opt_hint_clause  */
  YYSYMBOL_hint_list = 233,                /* hint_list  */
  YYSYMBOL_hint_item = 234,                /* hint_item  */
  YYSYMBOL_expr = 235,                     /* expr  */
  YYSYMBOL_function = 236,                 /* function  */
  YYSYMBOL_arglist = 237,                  /* arglist  */
  YYSYMBOL_arg = 238,                      /* arg  */
  YYSYMBOL_json_aggr = 239,                /* json_aggr  */
  YYSYMBOL_consthash = 240,                /* consthash  */
  YYSYMBOL_hash_key = 241,                 /* hash_key  */
  YYSYMBOL_hash_val = 242,                 /* hash_val  */
  YYSYMBOL_show_stmt = 243,                /* show_stmt  */
  YYSYMBOL_like_filter = 244,              /* like_filter  */
  YYSYMBOL_show_what = 245,                /* show_what  */
  YYSYMBOL_index_or_table = 246,           /* index_or_table  */
  YYSYMBOL_set_stmt = 247,                 /* set_stmt  */
  YYSYMBOL_opt_collate = 248,              /* opt_collate  */
  YYSYMBOL_set_global_stmt = 249,          /* set_global_stmt  */
  YYSYMBOL_set_string_value = 250,         /* set_string_value  */
  YYSYMBOL_bool_or_integer_value = 251,    /* bool_or_integer_value  */
  YYSYMBOL_set_value = 252,                /* set_value  */
  YYSYMBOL_simple_set_value = 253,         /* simple_set_value  */
  YYSYMBOL_transact_op = 254,              /* transact_op  */
  YYSYMBOL_start_transaction = 255,        /* start_transaction  */
  YYSYMBOL_insert_into = 256,              /* insert_into  */
  YYSYMBOL_insert_or_replace = 257,        /* insert_or_replace  */
  YYSYMBOL_opt_column_list = 258,          /* opt_column_list  */
  YYSYMBOL_column_ident = 259,             /* column_ident  */
  YYSYMBOL_column_list = 260,              /* column_list  */
  YYSYMBOL_insert_rows_list = 261,         /* insert_rows_list  */
  YYSYMBOL_insert_row = 262,               /* insert_row  */
  YYSYMBOL_insert_vals_list = 263,         /* insert_vals_list  */
  YYSYMBOL_insert_val = 264,               /* insert_val  */
  YYSYMBOL_delete_from = 265,              /* delete_from  */
  YYSYMBOL_266_2 = 266,                    /* $@2  */
  YYSYMBOL_call_proc = 267,                /* call_proc  */
  YYSYMBOL_call_args_list = 268,           /* call_args_list  */
  YYSYMBOL_call_arg = 269,                 /* call_arg  */
  YYSYMBOL_const_string_list = 270,        /* const_string_list  */
  YYSYMBOL_opt_call_opts_list = 271,       /* opt_call_opts_list  */
  YYSYMBOL_call_opts_list = 272,           /* call_opts_list  */
  YYSYMBOL_call_opt = 273,                 /* call_opt  */
  YYSYMBOL_opt_as = 274,                   /* opt_as  */
  YYSYMBOL_call_opt_name = 275,            /* call_opt_name  */
  YYSYMBOL_describe = 276,                 /* describe  */
  YYSYMBOL_describe_opt = 277,             /* describe_opt  */
  YYSYMBOL_describe_tok = 278,             /* describe_tok  */
  YYSYMBOL_update = 279,                   /* update  */
  YYSYMBOL_280_3 = 280,                    /* $@3  */
  YYSYMBOL_update_items_list = 281,        /* update_items_list  */
  YYSYMBOL_update_item = 282,              /* update_item  */
  YYSYMBOL_opt_show_variables_where_or_like = 283, /* opt_show_variables_where_or_like  */
  YYSYMBOL_show_variables_where = 284,     /* show_variables_where  */
  YYSYMBOL_show_variables_where_list = 285, /* show_variables_where_list  */
  YYSYMBOL_show_variables_where_entry = 286, /* show_variables_where_entry  */
  YYSYMBOL_set_transaction = 287,          /* set_transaction  */
  YYSYMBOL_opt_scope = 288,                /* opt_scope  */
  YYSYMBOL_isolation_level = 289,          /* isolation_level  */
  YYSYMBOL_attach_index = 290,             /* attach_index  */
  YYSYMBOL_opt_with_truncate = 291,        /* opt_with_truncate  */
  YYSYMBOL_flush_rtindex = 292,            /* flush_rtindex  */
  YYSYMBOL_flush_ramchunk = 293,           /* flush_ramchunk  */
  YYSYMBOL_flush_index = 294,              /* flush_index  */
  YYSYMBOL_flush_hostnames = 295,          /* flush_hostnames  */
  YYSYMBOL_flush_logs = 296,               /* flush_logs  */
  YYSYMBOL_select_sysvar = 297,            /* select_sysvar  */
  YYSYMBOL_sysvar_list = 298,              /* sysvar_list  */
  YYSYMBOL_sysvar_item = 299,              /* sysvar_item  */
  YYSYMBOL_sysvar_name = 300,              /* sysvar_name  */
  YYSYMBOL_select_dual = 301,              /* select_dual  */
  YYSYMBOL_truncate = 302,                 /* truncate  */
  YYSYMBOL_rtindex = 303,                  /* rtindex  */
  YYSYMBOL_opt_with_reconfigure = 304,     /* opt_with_reconfigure  */
  YYSYMBOL_optimize_index = 305,           /* optimize_index  */
  YYSYMBOL_306_4 = 306,                    /* $@4  */
  YYSYMBOL_reload_plugins = 307,           /* reload_plugins  */
  YYSYMBOL_json_field = 308,               /* json_field  */
  YYSYMBOL_json_expr = 309,                /* json_expr  */
  YYSYMBOL_subscript = 310,                /* subscript  */
  YYSYMBOL_subkey = 311,                   /* subkey  */
  YYSYMBOL_streq = 312,                    /* streq  */
  YYSYMBOL_strval = 313,                   /* strval  */
  YYSYMBOL_opt_distinct_item = 314,        /* opt_distinct_item  */
  YYSYMBOL_opt_facet_by_items_list = 315,  /* opt_facet_by_items_list  */
  YYSYMBOL_facet_by = 316,                 /* facet_by  */
  YYSYMBOL_facet_item = 317,               /* facet_item  */
  YYSYMBOL_facet_expr = 318,               /* facet_expr  */
  YYSYMBOL_facet_items_list = 319,         /* facet_items_list  */
  YYSYMBOL_facet_stmt = 320,               /* facet_stmt  */
  YYSYMBOL_opt_reload_index_from = 321,    /* opt_reload_index_from  */
  YYSYMBOL_reload_index = 322,             /* reload_index  */
  YYSYMBOL_reload_indexes = 323,           /* reload_indexes  */
  YYSYMBOL_sysfilters = 324,               /* sysfilters  */
  YYSYMBOL_delete_cluster = 325,           /* delete_cluster  */
  YYSYMBOL_explain_query = 326,            /* explain_query  */
  YYSYMBOL_327_5 = 327                     /* $@5  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  269
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   6448

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  159
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  169
/* YYNRULES -- Number of rules.  */
#define YYNRULES  580
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1031

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   510


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   148,   140,     2,
     153,   154,   146,   144,   152,   145,     2,   147,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   151,   150,
     142,   141,   143,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   157,     2,   158,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   155,   139,   156,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     2,     2,
       6,     7,     8,     9,     2,     2,     2,     2,     2,    12,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   117,     2,
       3,     4,     5,    10,    11,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     149
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   187,   187,   188,   189,   190,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   241,   242,   242,   242,   242,   242,   242,   243,   243,
     243,   243,   243,   244,   244,   244,   244,   244,   244,   245,
     245,   245,   245,   245,   246,   246,   246,   247,   247,   247,
     247,   247,   248,   248,   248,   248,   248,   248,   248,   249,
     249,   249,   249,   249,   250,   250,   250,   250,   250,   250,
     251,   251,   251,   252,   252,   252,   252,   252,   253,   253,
     253,   253,   254,   254,   254,   254,   254,   255,   255,   255,
     255,   255,   255,   256,   256,   256,   256,   256,   256,   257,
     257,   257,   257,   258,   258,   258,   258,   258,   262,   262,
     266,   266,   266,   266,   266,   270,   270,   270,   270,   270,
     278,   284,   284,   284,   284,   288,   289,   297,   304,   309,
     317,   318,   322,   329,   330,   334,   335,   339,   340,   343,
     345,   346,   351,   352,   356,   357,   358,   365,   370,   374,
     382,   386,   396,   397,   404,   405,   406,   410,   414,   421,
     422,   429,   430,   431,   438,   439,   440,   444,   445,   446,
     450,   451,   459,   460,   467,   469,   473,   477,   484,   485,
     489,   502,   509,   511,   516,   522,   532,   531,   544,   545,
     549,   550,   553,   555,   556,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   572,   573,   576,   578,   582,   586,
     587,   588,   589,   590,   594,   599,   607,   608,   609,   610,
     615,   623,   631,   639,   648,   653,   658,   663,   668,   673,
     678,   683,   688,   693,   698,   703,   708,   713,   718,   723,
     728,   733,   738,   743,   748,   753,   758,   763,   768,   773,
     778,   783,   790,   800,   806,   817,   824,   833,   837,   846,
     850,   854,   858,   862,   872,   873,   878,   884,   890,   896,
     897,   898,   899,   900,   904,   905,   909,   917,   928,   929,
     936,   937,   941,   947,   954,   960,   966,   968,   971,   973,
     980,   984,   990,   992,   998,  1000,  1004,  1015,  1017,  1021,
    1025,  1032,  1033,  1037,  1038,  1039,  1042,  1044,  1048,  1052,
    1056,  1062,  1064,  1068,  1072,  1073,  1077,  1082,  1087,  1092,
    1098,  1103,  1111,  1116,  1123,  1130,  1132,  1136,  1137,  1141,
    1145,  1149,  1159,  1160,  1161,  1162,  1163,  1164,  1165,  1166,
    1168,  1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,  1177,
    1178,  1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,
    1188,  1189,  1190,  1191,  1195,  1196,  1197,  1198,  1199,  1200,
    1201,  1202,  1203,  1204,  1205,  1206,  1207,  1208,  1209,  1210,
    1214,  1215,  1219,  1220,  1224,  1225,  1226,  1229,  1231,  1232,
    1236,  1237,  1238,  1242,  1243,  1244,  1250,  1253,  1255,  1259,
    1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,  1272,  1277,
    1282,  1287,  1292,  1297,  1301,  1305,  1309,  1313,  1320,  1321,
    1327,  1332,  1337,  1342,  1343,  1344,  1347,  1349,  1353,  1358,
    1363,  1368,  1374,  1381,  1391,  1392,  1396,  1397,  1398,  1402,
    1403,  1407,  1408,  1409,  1410,  1411,  1418,  1419,  1420,  1424,
    1425,  1431,  1435,  1436,  1439,  1441,  1445,  1449,  1450,  1454,
    1455,  1459,  1463,  1464,  1468,  1469,  1470,  1471,  1472,  1478,
    1478,  1488,  1496,  1500,  1507,  1508,  1515,  1525,  1531,  1533,
    1537,  1542,  1546,  1553,  1555,  1559,  1560,  1566,  1572,  1574,
    1581,  1582,  1589,  1589,  1597,  1598,  1602,  1616,  1622,  1626,
    1631,  1645,  1651,  1660,  1661,  1665,  1669,  1670,  1674,  1678,
    1684,  1686,  1690,  1697,  1698,  1699,  1700,  1706,  1715,  1717,
    1726,  1735,  1744,  1752,  1760,  1770,  1778,  1779,  1783,  1787,
    1791,  1801,  1809,  1810,  1813,  1815,  1824,  1824,  1834,  1845,
    1846,  1850,  1853,  1854,  1858,  1859,  1860,  1861,  1862,  1866,
    1867,  1871,  1876,  1878,  1879,  1882,  1884,  1888,  1897,  1901,
    1909,  1910,  1914,  1927,  1929,  1936,  1944,  1952,  1960,  1969,
    1969
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "\"identifier\"",
  "\"`identifier`\"", "TOK_ATIDENT", "\"integer\"", "\"float\"",
  "TOK_CONST_MVA", "\"string\"", "\"@uservar\"", "\"@@sysvar\"",
  "TOK_CONST_STRINGS", "TOK_BAD_NUMERIC", "TOK_SUBKEY",
  "TOK_BACKTICKED_SUBKEY", "\".number\"", "TOK_AGENT", "TOK_ALL",
  "TOK_ANY", "TOK_AS", "TOK_ASC", "TOK_ATTACH", "TOK_ATTRIBUTES",
  "TOK_AVG", "TOK_BEGIN", "TOK_BETWEEN", "TOK_BIGINT", "TOK_BY",
  "TOK_CALL", "TOK_CHARACTER", "TOK_CHUNK", "TOK_CLUSTER", "TOK_COLLATE",
  "TOK_COLLATION", "TOK_COLUMN", "TOK_COMMIT", "TOK_COMMITTED",
  "TOK_COUNT", "TOK_CREATE", "TOK_DATABASES", "TOK_DEBUGCLAUSE",
  "TOK_DELETE", "TOK_DESC", "TOK_DESCRIBE", "TOK_DISTINCT", "TOK_DIV",
  "TOK_DOUBLE", "TOK_EXPLAIN", "TOK_FACET", "TOK_FALSE", "TOK_FLOAT",
  "TOK_FLUSH", "TOK_FOR", "TOK_FORCE", "TOK_FROM", "TOK_GLOBAL",
  "TOK_GROUP", "TOK_GROUPBY", "TOK_GROUP_CONCAT", "TOK_HAVING",
  "TOK_HOSTNAMES", "TOK_IGNORE", "TOK_IN", "TOK_INDEX", "TOK_INDEXES",
  "TOK_INDEXOF", "TOK_INSERT", "TOK_INT", "TOK_INTEGER", "TOK_INTO",
  "TOK_IS", "TOK_ISOLATION", "TOK_LEVEL", "TOK_LIKE", "TOK_LIMIT",
  "TOK_LOGS", "TOK_MATCH", "TOK_MAX", "TOK_META", "TOK_MIN", "TOK_MOD",
  "TOK_MULTI", "TOK_MULTI64", "TOK_NAMES", "TOK_NOT", "TOK_NULL",
  "TOK_OFFSET", "TOK_OPTION", "TOK_ORDER", "TOK_OPTIMIZE", "TOK_PLAN",
  "TOK_PLUGINS", "TOK_PROFILE", "TOK_RAND", "TOK_RAMCHUNK", "TOK_READ",
  "TOK_REGEX", "TOK_RECONFIGURE", "TOK_RELOAD", "TOK_REPEATABLE",
  "TOK_REPLACE", "TOK_REMAP", "TOK_ROLLBACK", "TOK_RTINDEX", "TOK_SELECT",
  "TOK_SERIALIZABLE", "TOK_SET", "TOK_SETTINGS", "TOK_SESSION", "TOK_SHOW",
  "TOK_SONAME", "TOK_START", "TOK_STATUS", "TOK_STRING", "TOK_SYSFILTERS",
  "TOK_SUM", "TOK_TABLE", "TOK_TABLES", "TOK_THREADS", "TOK_TO",
  "TOK_TRANSACTION", "TOK_TRUE", "TOK_TRUNCATE", "TOK_UNCOMMITTED",
  "TOK_UPDATE", "TOK_USE", "TOK_VALUES", "TOK_VARIABLES", "TOK_WARNINGS",
  "TOK_WEIGHT", "TOK_WHERE", "TOK_WITH", "TOK_WITHIN", "\"<=\"", "\">=\"",
  "\"!=\"", "TOK_OR", "TOK_AND", "'|'", "'&'", "'='", "'<'", "'>'", "'+'",
  "'-'", "'*'", "'/'", "'%'", "TOK_NEG", "';'", "':'", "','", "'('", "')'",
  "'{'", "'}'", "'['", "']'", "$accept", "request", "statement",
  "ident_set_no_option", "ident_set", "ident", "ident_no_option",
  "identidx", "one_index", "only_one_index", "chunk_key", "chunk_keys",
  "string_key", "string_keys", "multi_strings_and_maybe_chunk_key",
  "multi_chunks_and_maybe_string_key", "fromkeys",
  "one_index_opt_subindex", "one_index_opt_chunk", "from_target",
  "list_of_indexes", "string_nokeys",
  "multi_strings_and_maybe_chunk_nokey", "sysvar", "sysvar_ext",
  "multi_stmt_list", "multi_stmt", "select", "select1",
  "opt_tablefunc_args", "tablefunc_args_list", "tablefunc_arg",
  "subselect_start", "opt_outer_order", "opt_outer_limit", "select_from",
  "$@1", "select_items_list", "select_item", "opt_alias", "select_expr",
  "ident_list", "opt_where_clause", "where_clause", "where_expr",
  "where_item", "filter_expr", "filter_item", "expr_ident", "mva_aggr",
  "const_int", "const_float", "const_float_unsigned", "const_list",
  "string_list", "opt_group_clause", "opt_int", "group_items_list",
  "opt_having_clause", "opt_group_order_clause", "group_order_clause",
  "opt_order_clause", "order_clause", "order_items_list", "order_item",
  "opt_limit_clause", "limit_clause", "opt_option_clause", "option_clause",
  "option_list", "option_item", "named_const_list", "named_const",
  "opt_hint_clause", "hint_list", "hint_item", "expr", "function",
  "arglist", "arg", "json_aggr", "consthash", "hash_key", "hash_val",
  "show_stmt", "like_filter", "show_what", "index_or_table", "set_stmt",
  "opt_collate", "set_global_stmt", "set_string_value",
  "bool_or_integer_value", "set_value", "simple_set_value", "transact_op",
  "start_transaction", "insert_into", "insert_or_replace",
  "opt_column_list", "column_ident", "column_list", "insert_rows_list",
  "insert_row", "insert_vals_list", "insert_val", "delete_from", "$@2",
  "call_proc", "call_args_list", "call_arg", "const_string_list",
  "opt_call_opts_list", "call_opts_list", "call_opt", "opt_as",
  "call_opt_name", "describe", "describe_opt", "describe_tok", "update",
  "$@3", "update_items_list", "update_item",
  "opt_show_variables_where_or_like", "show_variables_where",
  "show_variables_where_list", "show_variables_where_entry",
  "set_transaction", "opt_scope", "isolation_level", "attach_index",
  "opt_with_truncate", "flush_rtindex", "flush_ramchunk", "flush_index",
  "flush_hostnames", "flush_logs", "select_sysvar", "sysvar_list",
  "sysvar_item", "sysvar_name", "select_dual", "truncate", "rtindex",
  "opt_with_reconfigure", "optimize_index", "$@4", "reload_plugins",
  "json_field", "json_expr", "subscript", "subkey", "streq", "strval",
  "opt_distinct_item", "opt_facet_by_items_list", "facet_by", "facet_item",
  "facet_expr", "facet_items_list", "facet_stmt", "opt_reload_index_from",
  "reload_index", "reload_indexes", "sysfilters", "delete_cluster",
  "explain_query", "$@5", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   379,   380,   381,   382,   260,   261,   262,   263,
     383,   384,   269,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   378,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   124,
      38,    61,    60,    62,    43,    45,    42,    47,    37,   510,
      59,    58,    44,    40,    41,   123,   125,    91,    93
};
#endif

#define YYPACT_NINF (-882)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-562)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    6292,    23,  -882,  4928,  -882,  -882,   117,  -882,  -882,  -882,
     283,  -882,  -882,    36,  -882,  -882,  1040,  5575,   640,   154,
    2560,   135,  -882,   242,   112,     6,  -882,  -882,  -882,  -882,
    -882,  -882,  -882,  -882,  -882,  -882,    85,  -882,  -882,  -882,
    5059,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,
    -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  5190,
    -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,
    -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,
    -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,
    -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,
    -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,
    -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,
    -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,
    -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,
    -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,
    -882,  -882,  -882,  -882,   143,  4928,   296,  4928,  -882,  -882,
    -882,  5190,  5190,   288,  5190,  -882,   302,   230,  -882,  -882,
    -882,  -882,  -882,   260,  -882,   237,   238,   248,   255,   271,
     282,   286,   289,   300,   303,   331,   334,   337,   340,  2111,
     341,   354,   369,   374,   375,  2111,  -882,  2111,  3880,    69,
    -882,    19,  -882,  4273,   185,  -882,   376,   -16,  -882,  4273,
      68,   102,  -882,   233,   305,  4928,  5706,  5190,  3749,   250,
     319,   323,   315,  4404,   424,  -882,   415,   459,  -882,  -882,
     459,  -882,  -882,  -882,  -882,   459,  -882,   459,  -882,  -882,
     464,  5321,   430,  -882,  -882,  -882,   406,   407,   409,   410,
     411,   412,   413,   418,   419,   420,   562,  2560,    75,    97,
    -882,   370,   219,   -14,  -882,  -882,  -882,  5059,  5059,  -882,
    -882,  2111,   190,  -882,  5059,   423,   425,   427,   428,   431,
     432,  -882,  -882,   213,   467,  -882,  -882,  -882,  -882,  -882,
     461,    72,  -882,  5059,  4928,  -882,  -882,  5190,   534,   479,
    1193,   577,   578,  -882,   580,   581,  -882,  2111,  2264,    63,
    2264,  2264,   442,  2111,  2264,  2264,  2111,  2111,   445,   446,
     447,  -882,  1346,  2264,  2111,  2111,   448,  -882,   894,  -882,
    -882,  -882,   105,   462,  -882,  -882,  -882,  2417,    75,  -882,
    3092,  1499,  4928,  -882,  -882,  2111,  2111,  2111,  2111,  2111,
    2111,  2111,  2111,  2111,  2111,  2111,  2111,  2111,  2111,  2111,
    2111,  2111,  2111,   598,   594,  -882,  -882,  -882,   453,   199,
    2111,  3749,   551,   470,   471,   552,  -882,  -882,  -882,  -882,
    -882,     8,  -882,  3225,  3749,   541,   502,   -17,   503,  -882,
    5190,   608,  -882,  -882,  -882,  -882,  5452,  -882,  -882,    28,
     466,    76,   110,   468,   -18,  4928,  4928,  4928,   473,  4928,
     472,   475,  4928,  4928,   491,  -882,     7,  2560,  2560,   474,
     494,    59,    37,   203,    80,    59,    59,   114,   141,    59,
      59,    48,   495,    79,    48,    48,    48,    48,    48,    48,
      48,    48,   489,   518,  6232,  -882,  4273,    16,  1652,  5829,
    -882,   497,  5190,  -882,  -882,   643,   639,   639,  -882,  -882,
     459,   554,  -882,  -882,  -882,   262,    34,  -882,  -882,  -882,
    -882,   504,  -882,   524,   650,   464,   651,  -882,   652,   523,
    1805,  -882,  6232,   147,  -882,  -882,   577,  -882,   578,  5905,
     153,  4928,   511,   159,   163,  -882,  5937,   182,   186,  5833,
    5869,  1958,  2111,  2111,  -882,   195,   196,  6077,  5973,  -882,
    -882,  3880,  -882,  3487,   510,   496,  -882,   213,  -882,   213,
    -882,   468,  -882,  -882,  6232,  -882,  -882,  -882,   351,   351,
     769,  6128,  6300,   693,   646,   769,  -882,   351,   351,    12,
      12,  -882,  -882,  -882,  6284,   -41,  -882,  2264,   583,  -882,
     769,   526,   663,   520,  3618,   665,  3749,  3749,  -882,  -882,
    -882,  -882,  -882,  -882,  -882,  -882,  -882,   526,   603,   459,
    -882,   459,  -882,  -882,  -882,  -882,  -882,  -882,  -882,   536,
     529,  -882,  -882,  5059,  -882,    76,  -882,   459,  5059,  4928,
    -882,  -882,  -882,   528,   530,    75,   531,   532,   533,  -882,
    -882,   535,    75,   538,  -882,  -882,  -882,   540,  -882,   679,
     679,   553,   555,  -882,    30,   609,  -882,   544,   545,    48,
      39,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,
    -882,  -882,  -882,  -882,  -882,   556,    48,    48,   546,  -882,
    -882,  -882,  -882,  -882,  -882,  -882,  -882,   602,  -882,  4928,
    -882,  -882,  2111,   656,  2111,  4928,   575,  -882,  -882,   639,
    -882,  5190,  -882,  -882,  -882,  -882,   204,   211,    72,   549,
    2693,   464,   464,  -882,  -882,  -882,  1499,   557,  2264,  -882,
    -882,  -882,  -882,   559,  -882,  -882,  -882,  -882,  -882,  -882,
    2111,  -882,  2111,  -882,  6113,  6145,  -882,  -882,  2111,  -882,
     564,  -882,  -882,  -882,  -882,  -882,  -882,   639,  -882,   601,
     639,    76,    76,  -882,  -882,  -882,   524,  4928,   701,   702,
     215,  -882,   568,    48,  -882,  -882,   569,   526,  -882,   181,
    -882,  -882,  2959,  5452,  -882,  -882,  -882,  -882,   574,   579,
    -882,  -882,  -882,  -882,  -882,  -882,  -882,   708,  -882,   218,
     221,    59,    59,   225,   232,  -882,   679,   679,   582,  -882,
      30,    48,   259,   584,    48,  -882,    46,    10,  -882,   585,
    -882,  4928,   629,   572,  -882,  -882,   264,   587,   589,    48,
    -882,   716,  -882,    56,  -882,   586,  -882,  -882,   588,  2826,
    -882,   592,   155,  -882,  -882,   590,  -882,  -882,  6009,  6041,
    6164,  3487,  1499,   593,    76,   677,  -882,   672,  -882,  -882,
    -882,  3618,   265,   591,    14,   641,  -882,  -882,  -882,  -882,
    4928,   595,  -882,   727,  4928,   596,   734,  -882,  -882,  -882,
    -882,  -882,  -882,  -882,  -882,   269,   275,    48,   295,   298,
    -882,  -882,    48,   307,    88,  4928,   464,    59,  -882,   723,
     680,  -882,  4928,  -882,   103,    -6,  -882,   631,  -882,  -882,
    -882,  -882,  4535,   103,   743,   607,  2560,  2693,  4666,   610,
    -882,  -882,   612,  -882,    25,   667,   755,   630,  4928,  -882,
    -882,  -882,    48,  -882,  -882,  -882,   621,   311,  -882,   757,
    -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,
    -882,  -882,    29,  -882,  -882,  -882,   157,  -882,  -882,  4011,
    -882,  -882,    44,   348,  -882,   587,  -882,  -882,  -882,  -882,
    -882,   747,  -882,   616,   762,    97,   634,  -882,  -882,   624,
    -882,  -882,  2264,  4797,   750,   704,  -882,   756,   726,   725,
    -882,   642,   349,    48,  4928,  -882,   645,  -882,   362,   731,
     736,   737,  -882,   157,  -882,   653,    82,   655,  -882,   103,
    -882,  -882,  -882,   649,  2560,  4666,   363,  4142,   798,  -882,
    4142,   720,  3356,   629,  -882,  -882,  -882,  -882,  -882,  -882,
     657,   659,   661,  -882,   662,  -882,  -882,  4142,  -882,   664,
      97,  -882,   668,   655,   -34,  -882,   670,   777,  -882,   680,
    4928,  4928,  4928,  -882,  -882,  -882,   671,   817,   819,  4142,
    4142,   464,  -882,   366,   367,   371,  2264,  -882,  -882,  -882,
     655,   157,  4928,  -882,  -882,  -882,   372,  -882,  -882,   676,
    -882
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,   459,     0,   456,    28,   479,   501,   500,   579,
       0,   462,   546,     0,   463,   457,     0,   520,   520,     0,
       0,     0,   502,     0,     2,     4,   174,   177,   180,   182,
     178,   179,     8,     9,   458,     6,     0,     7,    10,    11,
       0,    12,    17,    13,    14,    15,    16,    25,    26,    18,
      19,    20,    21,    22,    23,    24,    27,    29,    30,     0,
      31,   124,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,   123,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    63,    62,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,   121,   119,    81,    82,    83,    84,    86,    85,
      87,    88,    90,    91,    89,    92,    93,    94,    96,    97,
      95,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   122,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   120,     0,     0,     0,     0,   532,   533,
     534,     0,     0,     0,     0,   576,     0,    31,   343,   344,
     345,   561,   347,   169,   346,    33,    34,    38,    41,    50,
      56,    57,    63,    62,     0,    67,    70,    76,    78,     0,
      86,     0,    89,   103,   114,     0,   200,     0,   397,   342,
     539,     0,   198,   202,   205,   369,     0,   316,   536,   202,
       0,   370,   371,     0,    43,    45,    60,    66,     0,    95,
       0,     0,     0,     0,     0,   423,     0,   407,   521,   428,
     407,   414,   415,   413,   522,   407,   429,   407,   416,   409,
     321,     0,     0,   460,   275,   286,    33,    34,    41,    50,
      56,     0,    63,    70,     0,   114,     0,     0,   274,   577,
     226,     0,     0,     0,   279,   542,   543,     0,     0,     1,
       3,     0,     5,   176,     0,   130,   134,   132,   133,   131,
       0,   135,   137,   152,   498,   130,   134,   132,   133,   131,
       0,     0,   578,     0,     0,   531,   530,     0,   573,     0,
       0,   162,   165,   143,     0,   164,   170,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    31,    76,
      78,   349,     0,     0,     0,     0,     0,   348,     0,   401,
     402,   400,     0,     0,   554,   555,   556,     0,   551,   552,
       0,     0,     0,   203,   201,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   535,   317,   538,     0,     0,
       0,     0,     0,     0,     0,     0,   454,   455,   453,   452,
     451,   436,   449,     0,     0,     0,     0,   407,     0,   424,
       0,     0,   426,   411,   410,   425,     0,   406,   322,   101,
     137,   154,     0,   156,   407,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   287,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   544,     0,   569,   570,   202,   565,     0,     0,
     175,   464,     0,   142,   138,     0,     0,   145,   153,   499,
     407,     0,   290,   476,   291,     0,     0,   474,   475,   288,
     484,   488,   482,     0,     0,   321,     0,   575,     0,   393,
       0,   381,   392,     0,   390,   166,   163,   144,   167,     0,
       0,     0,     0,     0,     0,   212,     0,     0,     0,     0,
       0,     0,     0,     0,   387,     0,     0,     0,     0,   384,
     367,     0,   368,     0,   561,     0,   553,   171,   190,   149,
     196,   158,   159,   199,   205,   204,   359,   360,   361,   362,
     364,   366,   365,   357,   356,   363,   559,   354,   355,   350,
     351,   352,   353,   358,     0,   318,   537,     0,     0,   372,
     560,   435,     0,     0,     0,     0,     0,     0,   433,   445,
     447,   432,   446,   444,   448,   431,   430,   434,     0,   407,
     412,   407,   417,   408,   129,   128,   126,   127,   125,   326,
     323,   324,   422,     0,   140,   155,   421,   407,     0,     0,
     513,   427,   514,     0,     0,     0,     0,     0,     0,   283,
     277,     0,   550,     0,   549,   278,   229,   228,   227,     0,
       0,     0,     0,   240,     0,     0,   259,     0,     0,     0,
       0,   247,   256,   246,   255,   258,   249,   231,   257,   248,
     230,   245,   254,   244,   253,     0,     0,     0,     0,   271,
     272,   264,   263,   269,   270,   262,   261,     0,   541,     0,
     568,   567,     0,   562,     0,     0,     0,   136,   139,   146,
     497,     0,   289,   486,   478,   292,     0,     0,     0,     0,
       0,   321,   321,   547,   574,   548,     0,     0,     0,   374,
     168,   206,   378,     0,   211,   380,   379,   210,   375,   377,
       0,   207,     0,   208,     0,     0,   388,   389,     0,   209,
       0,   405,   404,   403,   398,   558,   557,   173,   172,     0,
     140,   147,   143,   150,   151,   157,   216,     0,     0,     0,
       0,   373,     0,     0,   440,   439,     0,   437,   450,     0,
     418,   419,     0,     0,   160,   141,   420,   161,     0,   515,
     516,   285,   284,   282,   276,   281,   280,     0,   294,     0,
       0,     0,     0,     0,     0,   260,     0,     0,     0,   241,
       0,     0,     0,     0,     0,   545,     0,     0,   504,     0,
     571,   563,   307,   566,   466,   467,     0,     0,   528,     0,
     477,     0,   485,   493,   483,   489,   490,   481,    75,     0,
     218,   219,   220,   480,   580,   184,   391,   213,     0,     0,
       0,     0,     0,     0,   148,   296,   217,     0,   320,   319,
     376,     0,     0,     0,     0,     0,   526,   519,   328,   331,
       0,   327,   325,     0,     0,     0,     0,   238,   236,   242,
     251,   252,   250,   232,   234,     0,     0,     0,     0,     0,
     267,   265,     0,     0,     0,     0,   321,     0,   564,     0,
     316,   308,     0,   465,     0,   321,   469,     0,   527,   293,
     487,   494,     0,     0,     0,    75,     0,     0,     0,     0,
     383,   382,     0,   399,     0,     0,   298,   304,     0,   443,
     442,   438,     0,   524,   523,   525,     0,     0,   332,     0,
     518,   517,   273,   295,   239,   237,   243,   233,   235,   268,
     266,   512,     0,   506,   507,   505,   335,   510,   511,     0,
     572,   468,     0,     0,   472,     0,   461,   529,   496,   495,
     492,   493,   491,     0,     0,   221,   222,   189,   188,   185,
     186,   181,     0,     0,     0,   192,   299,     0,     0,   302,
     305,     0,     0,     0,     0,   329,     0,   509,     0,     0,
       0,     0,   503,   336,   337,    86,   313,   309,   311,     0,
     471,   470,   224,     0,     0,     0,     0,     0,     0,   183,
       0,     0,     0,   307,   385,   441,   334,   333,   330,   508,
       0,     0,     0,   338,     0,   314,   315,     0,   473,     0,
     223,   187,     0,   191,   193,   300,   297,     0,   303,   316,
       0,     0,     0,   310,   312,   225,     0,     0,     0,     0,
       0,   321,   214,     0,     0,     0,     0,   195,   194,   301,
     306,   335,     0,   339,   341,   340,     0,   197,   215,     0,
     386
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -882,  -882,  -882,  -387,     5,    -3,  -882,   -47,   -27,   -37,
    -268,  -488,  -252,  -259,    38,  -882,  -882,  -882,  -142,  -882,
    -338,  -275,  -882,    -9,  -882,  -882,   571,  -882,   346,  -882,
    -882,  -134,  -882,  -882,  -882,   136,  -882,    42,   505,  -193,
    -882,  -693,  -882,  -643,  -882,   -15,   -19,  -121,  -400,  -882,
     109,  -358,   388,  -588,  -576,  -882,  -882,  -882,  -882,  -882,
    -882,  -119,  -882,  -881,  -132,  -836,  -882,  -470,  -882,  -882,
     123,  -882,   -87,  -159,  -882,   -85,   121,  -882,  -304,   188,
    -882,  -882,   356,    70,  -882,  -205,  -882,  -882,  -882,  -882,
    -882,  -531,   -86,  -342,   317,  -882,  -882,  -882,  -882,  -882,
      20,  -882,  -882,   -39,  -882,  -647,  -882,  -882,  -882,  -882,
     209,  -882,  -882,  -882,    15,  -882,  -882,  -882,  -882,  -882,
    -882,  -882,  -882,    40,  -882,  -882,  -882,    57,  -882,   864,
    -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,
     519,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -393,
      13,  -882,   548,  -882,   539,  -882,  -882,  -882,   235,  -882,
     236,  -882,  -882,  -882,  -882,  -882,  -882,  -882,  -882
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    23,    24,   152,   153,   199,   579,   281,   400,   401,
     735,   585,   303,   304,   458,   714,   715,   284,   402,   520,
     403,   305,   306,   200,   522,    25,    26,    27,    28,   869,
     929,   930,   709,   935,   969,    29,   716,   201,   202,   344,
     203,  1013,   805,   671,   790,   791,   416,   260,   261,   262,
     263,   468,   469,   666,   749,   877,   937,   996,   973,   939,
     940,   850,   851,   957,   958,   365,   366,   397,   398,   580,
     581,   887,   888,   952,   953,   954,   482,   205,   483,   484,
     206,   332,   333,   704,    30,   392,   240,   241,    31,   558,
      32,   565,   566,   381,   382,    33,    34,    35,    36,   656,
     775,   776,   855,   856,   913,   470,    37,   156,    38,   471,
     472,   667,   669,   785,   786,   862,   920,    39,   460,    40,
      41,   268,   767,   768,   591,   592,   739,   740,    42,   222,
     817,    43,   858,    44,    45,    46,    47,    48,    49,   207,
     208,   209,    50,    51,   267,   648,    52,   163,    53,   210,
     211,   338,   339,   212,   213,   772,   653,   654,   445,   446,
     447,   273,   477,    54,    55,    56,    57,    58,   157
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     154,   259,   521,   283,   490,   673,   493,   494,   221,   578,
     497,   498,   290,   282,   910,   456,   367,   258,   505,   506,
     603,   783,   220,   725,   457,   393,   753,   485,  -407,   551,
     394,   711,   395,   264,   750,   245,   245,   280,   754,   748,
     245,   556,   567,   663,   651,   279,   718,   613,   762,   759,
     245,   883,   487,  1007,   245,   271,   391,   391,   345,   363,
     334,   335,   336,   612,   289,   245,   462,   622,   624,   626,
     629,   632,   634,   806,   340,   464,   861,  -407,   245,   462,
     933,   463,   396,   334,   335,   336,   993,    59,   464,   334,
     335,   336,   454,   346,   245,   462,  -101,   901,   617,   618,
     164,   165,   391,   985,   464,   637,   619,   455,   491,   245,
     462,   719,   463,   589,   295,   296,  -407,   298,  1008,   464,
     245,   462,   440,   625,   846,   986,   443,   441,   166,  1020,
     464,   368,  -550,   584,  -101,   812,   364,   204,   884,   369,
    -550,   670,   638,   620,   417,   418,   915,   245,   462,   155,
     628,   473,   292,   557,   294,   274,   272,   464,   359,   360,
     361,   606,   845,  1011,   560,  -549,   289,   289,   652,   289,
     375,   341,   838,  -549,   256,   256,   843,   341,  -407,   256,
     835,   836,   570,   947,   839,  -540,   388,   844,   664,   256,
     614,   560,   760,   256,   582,   331,   282,   659,   664,   590,
     343,   793,   794,   337,   465,   487,   343,   914,  -484,   492,
    -484,   949,   372,   680,   727,   380,   921,   465,   586,   950,
     280,   374,   289,   587,   804,   466,   337,   453,   279,   454,
     442,   345,   337,   465,   417,   418,   562,   451,   280,   265,
     282,   902,   269,   720,   455,   431,   279,   282,   465,   707,
     475,   710,   266,   650,   258,   660,   912,   511,   457,   465,
     457,   512,   270,   562,   280,   280,   346,   712,   415,   462,
     264,   280,   279,   279,   301,   243,   302,   814,   464,   279,
     880,   815,   432,   951,   548,   549,   465,   816,   615,   616,
     280,   474,   417,   867,   942,   448,   291,   449,   279,   678,
      18,   679,   289,   519,   433,   678,   158,   682,  1014,  1015,
     321,   678,   988,   685,   948,   678,   327,   686,   328,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   678,  -540,   688,   280,   678,   525,
     689,   627,   630,   572,   159,   279,   578,   678,   678,   696,
     697,   293,   297,   434,   435,   436,   779,   299,   780,   160,
     437,   438,   439,   781,   730,   782,   731,   678,   380,   810,
     826,  -522,   827,   826,   370,   828,   906,   779,   161,   833,
     563,   380,   736,   300,   826,   916,   834,   162,   419,   420,
    -395,  -394,   444,   830,   832,   289,   421,   345,   607,   608,
     467,   307,   593,   594,   595,   657,   595,   487,   308,   595,
     602,   779,   371,   841,   258,   258,   852,   779,   853,   881,
     596,   826,   598,   894,   309,   601,   604,   826,   489,   895,
     264,   264,   346,   422,   496,   310,   385,   499,   500,   311,
     221,   423,   312,   343,   584,   507,   508,   779,   659,   897,
     826,   659,   898,   313,   220,   424,   314,   289,   515,   779,
     383,   900,   524,   944,   384,   945,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   537,   538,   539,   540,
     541,   542,   543,   544,  -396,   941,   904,   315,   683,   908,
     316,   550,   564,   317,   322,   357,   358,   359,   360,   361,
     959,   779,   960,   975,   425,   426,   427,   323,   331,   956,
     702,   428,   429,   430,   779,   678,   979,   992,  1022,  1022,
    1023,  1024,   324,  1022,   678,  1025,  1029,   325,   326,   362,
     611,   389,   390,   391,   621,   623,   564,   564,   631,   633,
     635,  1021,   345,   639,   640,   641,   642,   643,   644,   645,
     646,   563,   396,   380,   380,   708,   734,   713,   404,   405,
     406,   737,   407,   408,   409,   410,   411,   956,   415,   524,
     995,   412,   413,   414,  -124,   665,  -123,   346,  -121,  -122,
     280,   461,  -120,   452,   459,   280,   738,   956,   279,   476,
     478,  -142,   301,   279,   486,   521,   495,   488,   501,   502,
     503,   328,   509,   513,   545,   173,   547,   552,   555,  1019,
     956,   553,   554,   568,   778,   569,   571,   573,   583,   597,
     588,   647,   703,   694,   695,   649,   599,   609,   966,   600,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   605,   766,   610,   636,   658,
     655,   792,   774,   453,   706,   670,   668,   223,   661,   672,
     674,   675,   769,   724,  -561,   684,   289,   258,   705,   721,
     224,   557,   722,   723,   225,   726,   729,   732,   418,   226,
     227,   733,   741,   264,   742,   743,   744,   745,   748,   746,
     747,   751,   345,   752,   761,   755,   228,   756,   757,   764,
     765,   771,   777,   787,   229,   801,   802,   808,   809,   811,
     813,   795,  1026,   797,   807,   823,   824,   825,   849,   230,
     837,   857,   842,   665,   652,   860,   847,   346,   758,   821,
     866,   231,   232,   233,   876,   878,   890,   885,   863,   345,
     854,   864,   868,   893,   882,   665,   763,   875,   889,   234,
     892,   909,   923,   235,   917,   363,   934,   236,   237,   238,
     924,   936,   943,   938,   931,   932,   946,   861,   848,   239,
     962,   963,   964,   444,   346,   444,   965,   467,   967,   968,
     347,   348,   349,   971,   970,   972,   258,   354,   355,   356,
     357,   358,   359,   360,   361,   980,   974,   524,   702,   978,
     981,   982,   264,   989,   994,  1010,   984,   987,   563,   997,
    1000,   798,  1001,   799,  1002,   345,  1003,   886,  1005,   800,
    1006,   738,  1009,  1017,  1016,  1018,   677,   347,   348,   349,
    1030,   991,   665,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   766,   450,   874,   803,   523,   925,   608,   774,
     346,   998,   926,   662,   999,  1004,   822,   977,   769,   919,
     829,   831,  1027,   258,   258,   928,   796,   700,   983,   665,
     840,   873,   911,   665,   728,   602,   961,   784,   922,   264,
     264,   891,   242,   546,     0,   905,   516,   770,   859,     0,
     773,   604,     0,   536,     0,     0,   519,     0,     0,     0,
       0,     0,     0,   347,   348,     0,   258,     0,     0,     0,
     703,   355,   356,   357,   358,   359,   360,   361,     0,     0,
     879,     0,   264,   524,     0,     0,     0,     0,     0,     0,
     280,     0,     0,     0,     0,     0,     0,     0,   279,     0,
     345,   886,     0,     0,     0,   990,   896,     0,     0,     0,
       0,   899,     0,   903,     0,     0,   907,     0,     0,     0,
       0,   258,   928,   467,   258,     0,     0,   258,     0,   258,
       0,     0,   467,     0,     0,   346,     0,   264,     0,     0,
     264,     0,     0,   264,   258,   264,     0,     0,     0,     0,
       0,   665,     0,     0,     0,     0,     0,  1012,  1012,  1012,
     264,     0,     0,     0,     0,     0,   258,   258,     0,     0,
       0,   665,     0,     0,     0,     0,     0,     0,     0,  1028,
       0,   665,   264,   264,     0,     0,     0,     0,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   167,    61,   168,   169,   170,   510,   171,
     172,   173,   976,     0,     0,     0,   174,    62,   175,   176,
       0,    65,    66,    67,   177,    69,    70,   178,   467,    72,
      73,    74,    75,    76,    77,    78,    79,    80,   179,    82,
      83,     0,    84,    85,    86,     0,     0,   180,     0,     0,
       0,   181,    89,    90,     0,     0,    91,    92,   182,   183,
      95,    96,     0,   184,    97,     0,   185,    99,   100,   186,
     102,     0,   103,   104,   105,     0,     0,   106,   187,   108,
     188,     0,   110,   111,   112,   189,     0,     0,   113,     0,
     114,   115,   116,   117,   190,   119,   120,   191,   121,     0,
     122,   123,   192,   125,   126,     0,   127,   128,   129,   130,
     131,   132,   133,   134,   135,     0,   193,   137,   138,   139,
     140,   141,     0,   142,   143,   144,     0,   145,   146,   147,
     194,   149,   150,   151,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   195,   196,     0,     0,     0,
       0,     0,     0,   197,     0,   198,   318,    61,   168,   169,
     170,     0,   479,   172,     0,     0,     0,     0,     0,   174,
      62,   175,   176,     0,    65,    66,    67,    68,    69,    70,
     178,     0,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,     0,    84,    85,    86,     0,     0,
     180,     0,     0,     0,   181,    89,    90,     0,     0,    91,
      92,    93,    94,    95,    96,     0,   184,    97,     0,   185,
      99,   100,   186,   102,     0,   103,   104,   105,     0,     0,
     106,   319,   108,   320,     0,   110,   111,   112,   189,     0,
       0,   113,     0,   114,   115,   116,   117,   190,   119,   120,
     191,   121,     0,   122,   123,   192,   125,   126,     0,   127,
     128,   129,   130,   131,   132,   133,   134,   135,     0,   136,
     137,   138,   139,   140,   141,     0,   142,   143,   144,     0,
     145,   146,   147,   194,   149,   150,   151,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   195,     0,
       0,     0,     0,     0,     0,     0,   480,   481,   198,   318,
      61,   168,   169,   170,     0,   479,   172,     0,     0,     0,
       0,     0,   174,    62,   175,   176,     0,    65,    66,    67,
      68,    69,    70,   178,     0,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,     0,    84,    85,
      86,     0,     0,   180,     0,     0,     0,   181,    89,    90,
       0,     0,    91,    92,    93,    94,    95,    96,     0,   184,
      97,     0,   185,    99,   100,   186,   102,     0,   103,   104,
     105,     0,     0,   106,   319,   108,   320,     0,   110,   111,
     112,   189,     0,     0,   113,     0,   114,   115,   116,   117,
     190,   119,   120,   191,   121,     0,   122,   123,   192,   125,
     126,     0,   127,   128,   129,   130,   131,   132,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,     0,   142,
     143,   144,     0,   145,   146,   147,   194,   149,   150,   151,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   195,     0,     0,     0,     0,     0,     0,     0,   197,
     504,   198,   318,    61,   168,   169,   170,     0,   171,   172,
       0,     0,     0,     0,     0,   174,    62,   175,   176,     0,
      65,    66,    67,   177,    69,    70,   178,     0,    72,    73,
      74,    75,    76,    77,    78,    79,    80,   179,    82,    83,
       0,    84,    85,    86,     0,     0,   180,     0,     0,     0,
     181,    89,    90,     0,     0,    91,    92,   182,   183,    95,
      96,     0,   184,    97,     0,   185,    99,   100,   186,   102,
       0,   103,   104,   105,     0,     0,   106,   187,   108,   188,
       0,   110,   111,   112,   189,     0,     0,   113,     0,   114,
     115,   116,   117,   190,   119,   120,   191,   121,     0,   122,
     123,   192,   125,   126,     0,   127,   128,   129,   130,   131,
     132,   133,   134,   135,     0,   193,   137,   138,   139,   140,
     141,     0,   142,   143,   144,     0,   145,   146,   147,   194,
     149,   150,   151,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   195,   196,     0,     0,     0,     0,
       0,     0,   197,     0,   198,   167,    61,   168,   169,   170,
       0,   171,   172,     0,     0,     0,     0,     0,   174,    62,
     175,   176,     0,    65,    66,    67,   177,    69,    70,   178,
       0,    72,    73,    74,    75,    76,    77,    78,    79,    80,
     179,    82,    83,     0,    84,    85,    86,     0,     0,   180,
       0,     0,     0,   181,    89,    90,     0,     0,    91,    92,
     182,   183,    95,    96,     0,   184,    97,     0,   185,    99,
     100,   186,   102,     0,   103,   104,   105,     0,     0,   106,
     187,   108,   188,     0,   110,   111,   112,   189,     0,     0,
     113,     0,   114,   115,   116,   117,   190,   119,   120,   191,
     121,     0,   122,   123,   192,   125,   126,     0,   127,   128,
     129,   130,   131,   132,   133,   134,   135,     0,   193,   137,
     138,   139,   140,   141,     0,   142,   143,   144,     0,   145,
     146,   147,   194,   149,   150,   151,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   195,   196,     0,
       0,     0,     0,     0,     0,   197,     0,   198,   318,    61,
     168,   169,   170,     0,   171,   172,     0,     0,     0,     0,
       0,   174,    62,   175,   176,     0,    65,    66,    67,    68,
      69,    70,   178,     0,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,     0,    84,    85,    86,
       0,     0,   180,     0,     0,     0,   181,    89,    90,     0,
       0,    91,    92,    93,    94,    95,    96,     0,   184,    97,
       0,   185,    99,   100,   186,   102,     0,   103,   104,   105,
       0,     0,   106,   319,   108,   320,     0,   110,   111,   112,
     189,     0,     0,   113,     0,   114,   115,   116,   117,   190,
     119,   120,   191,   121,     0,   122,   123,   192,   125,   126,
     676,   127,   128,   129,   130,   131,   132,   133,   134,   135,
       0,   136,   137,   138,   139,   140,   141,     0,   142,   143,
     144,     0,   145,   146,   147,   194,   149,   150,   151,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     195,     0,     0,     0,     0,     0,     0,     0,   197,     0,
     198,   318,    61,   168,   169,   170,     0,   479,   172,     0,
       0,     0,     0,     0,   174,    62,   175,   176,     0,    65,
      66,    67,    68,    69,    70,   178,     0,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,     0,
      84,    85,    86,     0,     0,   180,     0,     0,     0,   181,
      89,    90,     0,     0,    91,    92,    93,    94,    95,    96,
       0,   184,    97,     0,   185,    99,   100,   186,   102,     0,
     103,   104,   105,     0,     0,   106,   319,   108,   320,     0,
     110,   111,   112,   189,     0,     0,   113,     0,   114,   115,
     116,   117,   190,   119,   120,   191,   121,     0,   122,   123,
     192,   125,   126,     0,   127,   128,   129,   130,   131,   132,
     133,   134,   135,     0,   136,   137,   138,   139,   140,   141,
       0,   142,   143,   144,     0,   145,   146,   147,   194,   149,
     150,   151,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   195,     0,     0,     0,     0,     0,     0,
       0,   197,   481,   198,   318,    61,   168,   169,   170,     0,
     171,   172,     0,     0,     0,     0,     0,   174,    62,   175,
     176,     0,    65,    66,    67,    68,    69,    70,   178,     0,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,     0,    84,    85,    86,     0,     0,   180,     0,
       0,     0,   181,    89,    90,     0,     0,    91,    92,    93,
      94,    95,    96,     0,   184,    97,     0,   185,    99,   100,
     186,   102,     0,   103,   104,   105,     0,     0,   106,   319,
     108,   320,     0,   110,   111,   112,   189,     0,     0,   113,
       0,   114,   115,   116,   117,   190,   119,   120,   191,   121,
       0,   122,   123,   192,   125,   126,     0,   127,   128,   129,
     130,   131,   132,   133,   134,   135,     0,   136,   137,   138,
     139,   140,   141,     0,   142,   143,   144,     0,   145,   146,
     147,   194,   149,   150,   151,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   195,     0,     0,     0,
       0,     0,     0,     0,   197,     0,   198,   318,    61,   168,
     169,   170,     0,   479,   172,     0,     0,     0,     0,     0,
     174,    62,   175,   176,     0,    65,    66,    67,    68,    69,
      70,   178,     0,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,     0,    84,    85,    86,     0,
       0,   180,     0,     0,     0,   181,    89,    90,     0,     0,
      91,    92,    93,    94,    95,    96,     0,   184,    97,     0,
     185,    99,   100,   186,   102,     0,   103,   104,   105,     0,
       0,   106,   319,   108,   320,     0,   110,   111,   112,   189,
       0,     0,   113,     0,   114,   115,   116,   117,   190,   119,
     120,   191,   121,     0,   122,   123,   192,   125,   126,     0,
     127,   128,   129,   130,   131,   132,   133,   134,   135,     0,
     136,   137,   138,   139,   140,   141,     0,   142,   143,   144,
       0,   145,   146,   147,   194,   149,   150,   151,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   195,
       0,     0,     0,     0,     0,     0,     0,   197,     0,   198,
     318,    61,   168,   169,   170,     0,   514,   172,     0,     0,
       0,     0,     0,   174,    62,   175,   176,     0,    65,    66,
      67,    68,    69,    70,   178,     0,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,     0,    84,
      85,    86,     0,     0,   180,     0,     0,     0,   181,    89,
      90,     0,     0,    91,    92,    93,    94,    95,    96,     0,
     184,    97,     0,   185,    99,   100,   186,   102,     0,   103,
     104,   105,     0,     0,   106,   319,   108,   320,     0,   110,
     111,   112,   189,     0,     0,   113,     0,   114,   115,   116,
     117,   190,   119,   120,   191,   121,     0,   122,   123,   192,
     125,   126,     0,   127,   128,   129,   130,   131,   132,   133,
     134,   135,     0,   136,   137,   138,   139,   140,   141,     0,
     142,   143,   144,     0,   145,   146,   147,   194,   149,   150,
     151,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   195,    60,    61,   244,   245,     0,     0,     0,
     197,     0,   198,     0,     0,     0,     0,    62,   246,   247,
       0,    65,    66,    67,    68,    69,    70,   248,     0,    72,
      73,    74,    75,    76,    77,    78,    79,    80,   249,    82,
      83,     0,    84,    85,    86,     0,     0,   250,     0,   251,
       0,    88,    89,    90,     0,     0,    91,    92,   252,    94,
      95,    96,     0,     0,    97,     0,    98,    99,   100,   253,
     102,     0,   103,   104,   105,     0,     0,   106,   107,   108,
     109,     0,   110,   111,   112,     0,     0,     0,   113,     0,
     114,   115,   116,   117,   118,   119,   120,   254,   121,     0,
     122,   123,   124,   125,   126,     0,   127,   128,   129,   130,
     131,   132,   133,   134,   135,     0,   136,   137,   138,   139,
     140,   141,     0,   142,   143,   144,     0,   145,   146,   147,
     255,   149,   150,   151,     0,     0,    60,    61,   244,   245,
       0,     0,     0,     0,     0,   256,     0,     0,     0,     0,
      62,   246,   247,   257,    65,    66,    67,    68,    69,    70,
     248,     0,    72,    73,    74,    75,    76,    77,    78,    79,
      80,   249,    82,    83,     0,    84,    85,    86,     0,     0,
     250,     0,   251,     0,    88,    89,    90,     0,     0,    91,
      92,   252,    94,    95,    96,     0,     0,    97,     0,    98,
      99,   100,   253,   102,     0,   103,   104,   105,     0,     0,
     788,   107,   108,   109,     0,   110,   111,   112,     0,     0,
       0,   113,     0,   114,   115,   116,   117,   118,   119,   120,
     254,   121,     0,   122,   123,   124,   125,   126,     0,   127,
     128,   129,   130,   131,   132,   133,   134,   135,     0,   136,
     137,   138,   139,   140,   141,     0,   142,   143,   144,     0,
     145,   146,   147,   255,   149,   150,   151,     0,     0,    60,
      61,   244,   245,     0,     0,     0,     0,     0,   256,     0,
       0,     0,     0,    62,   246,   247,   789,    65,    66,    67,
      68,    69,    70,   248,     0,    72,    73,    74,    75,    76,
      77,    78,    79,    80,   249,    82,    83,     0,    84,    85,
      86,     0,     0,   250,     0,   251,     0,    88,    89,    90,
       0,     0,    91,    92,   252,    94,    95,    96,     0,     0,
      97,     0,    98,    99,   100,   253,   102,     0,   103,   104,
     105,     0,     0,   865,   107,   108,   109,     0,   110,   111,
     112,     0,     0,     0,   113,     0,   114,   115,   116,   117,
     118,   119,   120,   254,   121,     0,   122,   123,   124,   125,
     126,     0,   127,   128,   129,   130,   131,   132,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,     0,   142,
     143,   144,     0,   145,   146,   147,   255,   149,   150,   151,
       0,     0,    60,    61,     0,   818,     0,     0,   819,     0,
       0,   256,     0,     0,     0,     0,    62,    63,    64,   257,
      65,    66,    67,    68,    69,    70,    71,     0,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
       0,    84,    85,    86,     0,     0,    87,     0,     0,     0,
      88,    89,    90,     0,     0,    91,    92,    93,    94,    95,
      96,     0,     0,    97,     0,    98,    99,   100,   101,   102,
       0,   103,   104,   105,     0,     0,   106,   107,   108,   109,
       0,   110,   111,   112,     0,     0,     0,   113,     0,   114,
     115,   116,   117,   118,   119,   120,     0,   121,     0,   122,
     123,   124,   125,   126,     0,   127,   128,   129,   130,   131,
     132,   133,   134,   135,     0,   136,   137,   138,   139,   140,
     141,     0,   142,   143,   144,     0,   145,   146,   147,   148,
     149,   150,   151,     0,     0,    60,   275,     0,     0,     0,
       0,     0,     0,   517,     0,     0,     0,     0,     0,    62,
      63,    64,   820,    65,    66,    67,    68,    69,    70,    71,
       0,    72,    73,    74,    75,   276,    77,    78,    79,    80,
      81,    82,    83,     0,    84,    85,    86,     0,     0,    87,
       0,     0,     0,    88,    89,    90,     0,     0,    91,    92,
      93,    94,    95,    96,     0,     0,    97,     0,    98,    99,
     100,   101,   102,     0,   103,   104,   105,     0,     0,   106,
     107,   108,   109,     0,   110,   111,   277,     0,     0,     0,
     113,     0,   114,   115,   116,   117,   118,   119,   120,     0,
     121,     0,   122,   123,   124,   125,   126,     0,   127,   128,
     129,   130,   131,   132,   133,   134,   135,     0,   136,   137,
     138,   139,   140,   278,     0,   142,   143,   144,     0,   145,
     146,   147,   148,   149,   150,   151,     0,     0,    60,    61,
       0,   245,     0,     0,   559,     0,     0,     0,     0,     0,
       0,     0,    62,    63,    64,   518,    65,    66,    67,    68,
      69,    70,    71,     0,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,     0,    84,    85,    86,
       0,     0,    87,     0,     0,   560,    88,    89,    90,     0,
       0,    91,    92,    93,    94,    95,    96,     0,     0,    97,
       0,    98,    99,   100,   101,   102,     0,   103,   104,   105,
       0,     0,   106,   107,   108,   109,     0,   110,   111,   112,
       0,   561,     0,   113,     0,   114,   115,   116,   117,   118,
     119,   120,     0,   121,     0,   122,   123,   124,   125,   126,
       0,   127,   128,   129,   130,   131,   132,   133,   134,   135,
       0,   136,   137,   138,   139,   140,   141,   562,   142,   143,
     144,     0,   145,   146,   147,   148,   149,   150,   151,    60,
      61,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     256,     0,     0,    62,   246,   247,     0,    65,    66,    67,
      68,    69,    70,   248,     0,    72,    73,    74,    75,    76,
      77,    78,    79,    80,   249,    82,    83,     0,    84,    85,
      86,     0,     0,   250,     0,   251,     0,    88,    89,    90,
       0,     0,    91,    92,   252,    94,    95,    96,     0,     0,
      97,     0,    98,    99,   100,   253,   102,     0,   103,   104,
     105,     0,     0,   106,   107,   108,   109,     0,   110,   111,
     112,     0,     0,     0,   113,     0,   114,   115,   116,   117,
     118,   119,   120,   254,   121,     0,   122,   123,   124,   125,
     126,     0,   127,   128,   129,   130,   131,   132,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,     0,   142,
     143,   144,     0,   145,   146,   147,   255,   149,   150,   151,
      60,    61,     0,   245,     0,     0,   701,     0,     0,     0,
       0,   256,     0,     0,    62,    63,    64,     0,    65,    66,
      67,    68,    69,    70,    71,     0,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,     0,    84,
      85,    86,     0,     0,    87,     0,     0,     0,    88,    89,
      90,     0,     0,    91,    92,    93,    94,    95,    96,     0,
       0,    97,     0,    98,    99,   100,   101,   102,     0,   103,
     104,   105,     0,     0,   106,   107,   108,   109,     0,   110,
     111,   112,     0,     0,     0,   113,     0,   114,   115,   116,
     117,   118,   119,   120,     0,   121,     0,   122,   123,   124,
     125,   126,     0,   127,   128,   129,   130,   131,   132,   133,
     134,   135,     0,   136,   137,   138,   139,   140,   141,     0,
     142,   143,   144,     0,   145,   146,   147,   148,   149,   150,
     151,    60,    61,     0,   245,     0,     0,   559,     0,     0,
       0,     0,   256,     0,     0,    62,    63,    64,     0,    65,
      66,    67,    68,    69,    70,    71,     0,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,     0,
      84,    85,    86,     0,     0,    87,     0,     0,     0,    88,
      89,    90,     0,     0,    91,    92,    93,    94,    95,    96,
       0,     0,    97,     0,    98,    99,   100,   101,   102,     0,
     103,   104,   105,     0,     0,   106,   107,   108,   109,     0,
     110,   111,   112,     0,     0,     0,   113,     0,   114,   115,
     116,   117,   118,   119,   120,     0,   121,     0,   122,   123,
     124,   125,   126,     0,   127,   128,   129,   130,   131,   132,
     133,   134,   135,     0,   136,   137,   138,   139,   140,   141,
       0,   142,   143,   144,     0,   145,   146,   147,   148,   149,
     150,   151,    60,    61,     0,   376,   377,     0,   378,     0,
       0,     0,     0,   256,     0,     0,    62,    63,    64,     0,
      65,    66,    67,    68,    69,    70,    71,     0,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
       0,    84,    85,    86,     0,     0,    87,     0,     0,     0,
      88,    89,    90,     0,     0,    91,    92,    93,    94,    95,
      96,     0,     0,    97,     0,    98,    99,   100,   101,   102,
       0,   103,   104,   105,     0,     0,   106,   107,   108,   109,
       0,   110,   111,   112,     0,   379,     0,   113,     0,   114,
     115,   116,   117,   118,   119,   120,     0,   121,     0,   122,
     123,   124,   125,   126,     0,   127,   128,   129,   130,   131,
     132,   133,   134,   135,     0,   136,   137,   138,   139,   140,
     141,     0,   142,   143,   144,     0,   145,   146,   147,   148,
     149,   150,   151,    60,    61,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    62,    63,    64,
       0,    65,    66,    67,    68,    69,    70,    71,     0,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,     0,    84,    85,    86,     0,     0,    87,     0,     0,
       0,    88,    89,    90,     0,     0,    91,    92,    93,    94,
      95,    96,     0,   329,    97,     0,    98,    99,   100,   101,
     102,     0,   103,   104,   105,   330,     0,   106,   107,   108,
     109,     0,   110,   111,   112,     0,     0,     0,   113,     0,
     114,   115,   116,   117,   118,   119,   120,     0,   121,     0,
     122,   123,   124,   125,   126,     0,   127,   128,   129,   130,
     131,   132,   133,   134,   135,     0,   136,   137,   138,   139,
     140,   141,     0,   142,   143,   144,     0,   145,   146,   147,
     148,   149,   150,   151,    60,    61,   244,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    62,    63,
      64,     0,    65,    66,    67,    68,    69,    70,   248,     0,
      72,    73,    74,    75,    76,    77,    78,    79,    80,   249,
      82,    83,     0,    84,    85,    86,     0,     0,   250,     0,
     251,     0,    88,    89,    90,     0,     0,    91,    92,   252,
      94,    95,    96,     0,     0,    97,     0,    98,    99,   100,
     253,   102,     0,   103,   104,   105,     0,     0,   106,   107,
     108,   109,     0,   110,   111,   112,     0,     0,     0,   113,
       0,   114,   115,   116,   117,   955,   119,   120,     0,   121,
       0,   122,   123,   124,   125,   126,     0,   127,   128,   129,
     130,   131,   132,   133,   134,   135,     0,   136,   137,   138,
     139,   140,   141,     0,   142,   143,   144,     0,   145,   146,
     147,   255,   149,   150,   151,    60,    61,   244,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    62,
      63,    64,     0,    65,    66,    67,    68,    69,    70,   248,
       0,    72,    73,    74,    75,    76,    77,    78,    79,    80,
     249,    82,    83,     0,    84,    85,    86,     0,     0,   250,
       0,   251,     0,    88,    89,    90,     0,     0,    91,    92,
     252,    94,    95,    96,     0,     0,    97,     0,    98,    99,
     100,   253,   102,     0,   103,   104,   105,     0,     0,   106,
     107,   108,   109,     0,   110,   111,   112,     0,     0,     0,
     113,     0,   114,   115,   116,   117,   118,   119,   120,     0,
     121,     0,   122,   123,   124,   125,   126,     0,   127,   128,
     129,   130,   131,   132,   133,   134,   135,     0,   136,   137,
     138,   139,   140,   141,     0,   142,   143,   144,     0,   145,
     146,   147,   255,   149,   150,   151,    60,    61,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      62,    63,    64,   342,    65,    66,    67,    68,    69,    70,
      71,     0,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,     0,    84,    85,    86,     0,     0,
      87,     0,     0,     0,    88,    89,    90,     0,     0,    91,
      92,    93,    94,    95,    96,     0,     0,    97,     0,    98,
      99,   100,   101,   102,     0,   103,   104,   105,     0,     0,
     106,   107,   108,   109,     0,   110,   111,   112,     0,     0,
       0,   113,     0,   114,   115,   116,   117,   118,   119,   120,
       0,   121,     0,   122,   123,   124,   125,   126,     0,   127,
     128,   129,   130,   131,   132,   133,   134,   135,     0,   136,
     137,   138,   139,   140,   141,     0,   142,   143,   144,     0,
     145,   146,   147,   148,   149,   150,   151,    60,   275,     0,
       0,     0,     0,   386,     0,     0,     0,     0,     0,     0,
       0,    62,    63,    64,     0,    65,    66,    67,    68,    69,
      70,    71,     0,    72,    73,    74,    75,   276,    77,    78,
      79,    80,    81,    82,    83,     0,    84,    85,    86,     0,
       0,    87,     0,     0,     0,    88,    89,    90,     0,     0,
      91,    92,    93,    94,    95,    96,     0,     0,    97,     0,
      98,    99,   100,   101,   102,     0,   103,   104,   105,     0,
       0,   106,   107,   108,   109,     0,   110,   111,   277,     0,
       0,     0,   113,     0,   114,   115,   116,   117,   118,   119,
     120,     0,   121,     0,   122,   123,   124,   125,   126,     0,
     127,   128,   129,   130,   131,   132,   133,   387,   135,     0,
     136,   137,   138,   139,   140,   278,     0,   142,   143,   144,
       0,   145,   146,   147,   148,   149,   150,   151,    60,    61,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    62,    63,    64,     0,    65,    66,    67,    68,
      69,    70,    71,     0,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,     0,    84,    85,    86,
       0,     0,    87,     0,     0,     0,    88,    89,    90,     0,
       0,    91,    92,    93,    94,    95,    96,     0,     0,    97,
       0,    98,    99,   100,   101,   102,     0,   103,   104,   105,
     918,     0,   106,   107,   108,   109,     0,   110,   111,   112,
       0,     0,     0,   113,     0,   114,   115,   116,   117,   118,
     119,   120,     0,   121,     0,   122,   123,   124,   125,   126,
       0,   127,   128,   129,   130,   131,   132,   133,   134,   135,
       0,   136,   137,   138,   139,   140,   141,     0,   142,   143,
     144,     0,   145,   146,   147,   148,   149,   150,   151,    60,
      61,     0,   927,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    62,    63,    64,     0,    65,    66,    67,
      68,    69,    70,    71,     0,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,     0,    84,    85,
      86,     0,     0,    87,     0,     0,     0,    88,    89,    90,
       0,     0,    91,    92,    93,    94,    95,    96,     0,     0,
      97,     0,    98,    99,   100,   101,   102,     0,   103,   104,
     105,     0,     0,   106,   107,   108,   109,     0,   110,   111,
     112,     0,     0,     0,   113,     0,   114,   115,   116,   117,
     118,   119,   120,     0,   121,     0,   122,   123,   124,   125,
     126,     0,   127,   128,   129,   130,   131,   132,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,     0,   142,
     143,   144,     0,   145,   146,   147,   148,   149,   150,   151,
      60,   275,     0,     0,     0,     0,     0,     0,   517,     0,
       0,     0,     0,     0,    62,    63,    64,     0,    65,    66,
      67,    68,    69,    70,    71,     0,    72,    73,    74,    75,
     276,    77,    78,    79,    80,    81,    82,    83,     0,    84,
      85,    86,     0,     0,    87,     0,     0,     0,    88,    89,
      90,     0,     0,    91,    92,    93,    94,    95,    96,     0,
       0,    97,     0,    98,    99,   100,   101,   102,     0,   103,
     104,   105,     0,     0,   106,   107,   108,   109,     0,   110,
     111,   277,     0,     0,     0,   113,     0,   114,   115,   116,
     117,   118,   119,   120,     0,   121,     0,   122,   123,   124,
     125,   126,     0,   127,   128,   129,   130,   131,   132,   133,
     134,   135,     0,   136,   137,   138,   139,   140,   278,     0,
     142,   143,   144,     0,   145,   146,   147,   148,   149,   150,
     151,    60,    61,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    62,    63,    64,     0,    65,
      66,    67,    68,    69,    70,    71,     0,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,     0,
      84,    85,    86,     0,     0,    87,     0,     0,     0,    88,
      89,    90,     0,     0,    91,    92,    93,    94,    95,    96,
       0,     0,    97,     0,    98,    99,   100,   101,   102,     0,
     103,   104,   105,     0,     0,   106,   107,   108,   109,     0,
     110,   111,   112,     0,     0,     0,   113,     0,   114,   115,
     116,   117,   118,   119,   120,     0,   121,     0,   122,   123,
     124,   125,   126,     0,   127,   128,   129,   130,   131,   132,
     133,   134,   135,     0,   136,   137,   138,   139,   140,   141,
       0,   142,   143,   144,     0,   145,   146,   147,   148,   149,
     150,   151,    60,   275,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    62,    63,    64,     0,
      65,    66,    67,    68,    69,    70,    71,     0,    72,    73,
      74,    75,   276,    77,    78,    79,    80,    81,    82,    83,
       0,    84,    85,    86,     0,     0,    87,     0,     0,     0,
      88,    89,    90,     0,     0,    91,    92,    93,    94,    95,
      96,     0,     0,    97,     0,    98,    99,   100,   101,   102,
       0,   103,   104,   105,     0,     0,   106,   107,   108,   109,
       0,   110,   111,   277,     0,     0,     0,   113,     0,   114,
     115,   116,   117,   118,   119,   120,     0,   121,     0,   122,
     123,   124,   125,   126,     0,   127,   128,   129,   130,   131,
     132,   133,   134,   135,     0,   136,   137,   138,   139,   140,
     278,     0,   142,   143,   144,     0,   145,   146,   147,   148,
     149,   150,   151,    60,   285,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    62,    63,    64,
       0,    65,    66,    67,    68,    69,    70,    71,     0,    72,
      73,    74,    75,   286,    77,    78,    79,    80,    81,    82,
      83,     0,    84,    85,    86,     0,     0,    87,     0,     0,
       0,    88,    89,    90,     0,     0,    91,    92,    93,    94,
      95,    96,     0,     0,    97,     0,    98,    99,   100,   101,
     102,     0,   103,   104,   105,     0,     0,   106,   107,   108,
     109,     0,   110,   111,   287,     0,     0,     0,   113,     0,
     114,   115,   116,   117,   118,   119,   120,     0,   121,     0,
     122,   123,   124,   125,   126,     0,   127,   128,   129,   130,
     131,   132,   133,   134,   135,     0,   136,   137,   138,   139,
     140,   288,     0,   142,   143,   144,     0,   145,   146,   147,
     148,   149,   150,   151,    60,   275,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    62,    63,
      64,     0,    65,    66,    67,    68,    69,    70,    71,     0,
      72,    73,    74,    75,   276,    77,    78,    79,    80,    81,
      82,    83,     0,    84,    85,    86,     0,     0,    87,     0,
       0,     0,    88,    89,    90,     0,     0,    91,    92,    93,
      94,    95,    96,     0,     0,    97,     0,    98,    99,   100,
     101,   102,     0,   103,   104,   105,     0,     0,   106,   107,
     108,   109,     0,   110,   111,   277,     0,     0,     0,   113,
       0,   114,   115,   116,   117,   118,   119,   120,     0,   121,
       0,   122,   123,   124,   125,   126,     0,   127,   128,   129,
     130,   131,   132,   133,   399,   135,     0,   136,   137,   138,
     139,   140,   278,     0,   142,   143,   144,     0,   145,   146,
     147,   148,   149,   150,   151,    60,   574,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    62,
      63,    64,     0,    65,    66,    67,    68,    69,    70,    71,
       0,    72,    73,    74,    75,   575,    77,    78,    79,    80,
      81,    82,    83,     0,    84,    85,    86,     0,     0,    87,
       0,     0,     0,    88,    89,    90,     0,     0,    91,    92,
      93,    94,    95,    96,     0,     0,    97,     0,    98,    99,
     100,   101,   102,     0,   103,   104,   105,     0,     0,   106,
     107,   108,   109,     0,   110,   111,   576,     0,     0,     0,
       0,     0,   114,   115,   116,   117,   118,   119,   120,     0,
     121,     0,   122,   123,   124,   125,   126,     0,   127,   128,
     129,   130,   131,   132,   133,   134,   135,     0,   136,   137,
     138,   139,   140,   577,     0,   142,   143,   144,    60,   145,
     146,   147,   148,   149,   150,   151,   173,     0,     0,     0,
       0,     0,    62,    63,    64,     0,    65,    66,    67,    68,
      69,    70,    71,     0,    72,   214,    74,   215,     0,    77,
      78,    79,    80,    81,    82,    83,     0,    84,    85,    86,
       0,     0,    87,     0,     0,     0,    88,    89,    90,     0,
       0,   216,    92,    93,    94,    95,    96,     0,     0,   217,
       0,    98,    99,   100,   101,   102,     0,   103,   104,   105,
       0,     0,   106,   107,   108,   109,     0,   110,   111,   218,
       0,     0,     0,   113,     0,   114,   115,   116,   117,   118,
     119,   120,     0,   121,     0,   122,   123,   124,   125,   126,
       0,   127,   128,   129,   219,   131,   132,   133,   134,   135,
       0,   136,   137,   138,   139,   140,     0,     0,   142,   143,
     144,     0,   145,   146,   147,   148,   149,   150,   151,    60,
       0,     0,     0,     0,     0,     0,   373,     0,     0,     0,
       0,     0,     0,    62,    63,    64,     0,    65,    66,    67,
      68,    69,    70,    71,     0,    72,    73,    74,    75,     0,
      77,    78,    79,    80,    81,    82,    83,     0,    84,    85,
      86,     0,     0,    87,     0,     0,     0,    88,    89,    90,
       0,     0,    91,    92,    93,    94,    95,    96,     0,     0,
      97,     0,    98,    99,   100,   101,   102,     0,   103,   104,
     105,     0,     0,   106,   107,   108,   109,     0,   110,   111,
       0,     0,     0,     0,   113,     0,   114,   115,   116,   117,
     118,   119,   120,     0,   121,     0,   122,   123,   124,   125,
     126,     0,   127,   128,   129,   130,   131,   132,   133,   134,
     135,     0,   136,   137,   138,   139,   140,  -521,     0,   142,
     143,   144,    60,   145,   146,   147,   148,   149,   150,   151,
     173,     0,     0,     0,     0,     0,    62,    63,    64,     0,
      65,    66,    67,    68,    69,    70,    71,     0,    72,   214,
      74,    75,     0,    77,    78,    79,    80,    81,    82,    83,
       0,    84,    85,    86,     0,     0,    87,     0,     0,   345,
      88,    89,    90,     0,     0,    91,    92,    93,    94,    95,
      96,     0,     0,    97,     0,    98,    99,   100,   101,   102,
       0,   103,   104,   105,     0,     0,   106,   107,   108,   109,
       0,   110,   111,   218,   346,   345,     0,   113,     0,   114,
     115,   116,   117,   118,   119,   120,     0,   121,     0,   122,
     123,   124,   125,   126,     0,   127,   128,   129,   130,   131,
     132,   133,   134,   135,     0,   136,   137,   138,   139,   140,
     346,   345,   142,   143,   144,     0,   145,   146,   147,   148,
     149,   150,   151,     0,     0,     0,     0,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,     0,   345,     0,   690,   346,   691,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   346,   345,
       0,   692,     0,   693,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   346,   345,     0,     0,     0,   681,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,     0,   345,     0,     0,
     346,   687,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   346,   345,     0,     0,     0,   699,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   346,   345,
       0,     0,     0,   870,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   345,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
       0,   345,     0,     0,   346,   871,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   346,
     345,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   346,     0,     0,   698,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   346,     0,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   347,   348,   349,   690,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   345,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,     0,     0,     0,   692,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   346,     1,     0,   872,     2,     0,     0,
       0,     3,     0,     0,     0,     0,     0,     0,     4,     0,
     345,     0,     0,     5,     6,     7,     8,   717,     0,     0,
       9,     0,     0,     0,    10,     0,   345,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    11,
       0,     0,     0,     0,     0,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   346,    12,     0,     0,     0,     0,     0,     0,     0,
       0,    13,     0,    14,     0,    15,     0,    16,     0,    17,
       0,     0,    18,     0,    19,     0,     0,    20,     0,     0,
       0,     0,     0,     0,     0,    21,     0,    22,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   347,   348,   349,     0,     0,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361
};

static const yytype_int16 yycheck[] =
{
       3,    20,   340,    40,   308,   475,   310,   311,    17,   396,
     314,   315,    59,    40,   850,   283,   209,    20,   322,   323,
     413,   668,    17,   554,   283,   230,   614,   302,     0,   371,
     235,   519,   237,    20,   610,     6,     6,    40,   614,     9,
       6,    33,   384,     9,    28,    40,    87,    10,   636,    10,
       6,    37,   304,    87,     6,    49,    74,    74,    46,    75,
      14,    15,    16,   421,    59,     6,     7,   425,   426,   427,
     428,   429,   430,   716,    55,    16,    20,    49,     6,     7,
      55,     9,    88,    14,    15,    16,   967,    64,    16,    14,
      15,    16,    16,    81,     6,     7,   113,     9,    18,    19,
      64,    65,    74,    21,    16,    26,    26,    31,    45,     6,
       7,   152,     9,   131,   161,   162,    88,   164,   152,    16,
       6,     7,   136,     9,   767,    43,   268,   141,    92,  1010,
      16,    63,    63,   401,   151,   723,   152,    16,   124,    71,
      71,   131,    63,    63,   137,   138,   152,     6,     7,    32,
       9,   293,   155,   145,   157,    70,   150,    16,   146,   147,
     148,   154,   152,   999,    50,    63,   161,   162,   152,   164,
     217,   152,   760,    71,   145,   145,   764,   152,   150,   145,
     756,   757,   387,   154,   760,     0,   223,   141,   154,   145,
     153,    50,   153,   145,   399,   198,   223,   456,   154,   404,
     203,   671,   672,   157,   145,   457,   209,   854,   152,   146,
     154,    54,   215,   488,   556,   218,   863,   145,   108,    62,
     223,   216,   217,   113,   712,   153,   157,    14,   223,    16,
     267,    46,   157,   145,   137,   138,   122,   274,   241,   104,
     267,   153,     0,   547,    31,    26,   241,   274,   145,   517,
     297,   519,   117,   446,   257,   460,   153,   152,   517,   145,
     519,   156,   150,   122,   267,   268,    81,   519,     6,     7,
     257,   274,   267,   268,    14,   121,    16,    96,    16,   274,
     811,   100,    63,   126,    85,    86,   145,   106,    85,    86,
     293,   294,   137,   138,   882,   105,   153,   107,   293,   152,
     110,   154,   297,   340,    85,   152,    23,   154,  1001,  1002,
     189,   152,   959,   154,   902,   152,   195,   154,   197,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   152,   150,   154,   340,   152,   342,
     154,   427,   428,   390,    61,   340,   733,   152,   152,   154,
     154,    55,    64,   134,   135,   136,   152,    55,   154,    76,
     141,   142,   143,   152,   569,   154,   571,   152,   371,   154,
     152,   121,   154,   152,   141,   154,   846,   152,    95,   154,
     383,   384,   587,   153,   152,   855,   154,   104,    18,    19,
     153,   153,   271,   751,   752,   390,    26,    46,   417,   418,
     291,   153,   405,   406,   407,   452,   409,   659,   153,   412,
     413,   152,   107,   154,   417,   418,   152,   152,   154,   154,
     407,   152,   409,   154,   153,   412,   413,   152,   307,   154,
     417,   418,    81,    63,   313,   153,   121,   316,   317,   153,
     449,    71,   153,   446,   712,   324,   325,   152,   707,   154,
     152,   710,   154,   153,   449,    85,   153,   452,   337,   152,
     141,   154,   341,   152,   141,   154,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   153,   878,   844,   153,   491,   847,
     153,   370,   383,   153,   153,   144,   145,   146,   147,   148,
     152,   152,   154,   154,   134,   135,   136,   153,   511,   909,
     513,   141,   142,   143,   152,   152,   154,   154,   152,   152,
     154,   154,   153,   152,   152,   154,   154,   153,   153,   153,
     421,   107,   117,    74,   425,   426,   427,   428,   429,   430,
     431,  1011,    46,   434,   435,   436,   437,   438,   439,   440,
     441,   554,    88,   556,   557,   517,   583,   519,   128,   153,
     153,   588,   153,   153,   153,   153,   153,   967,     6,   448,
     970,   153,   153,   153,   151,   466,   151,    81,   151,   151,
     583,   120,   151,   151,   117,   588,   589,   987,   583,    55,
     111,    14,    14,   588,    14,   933,   154,    16,   153,   153,
     153,   480,   154,   141,     6,    11,   153,    56,    56,  1009,
    1010,   141,   141,    72,   661,   113,   113,     9,   152,   146,
     152,   132,   513,   502,   503,   107,   154,   153,   932,   154,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   154,   649,   153,   153,     6,
     153,   670,   655,    14,   158,   131,   152,    17,   104,     9,
       9,     9,   649,   554,   141,   154,   661,   670,   158,    86,
      30,   145,     9,   153,    34,    10,    73,   141,   138,    39,
      40,   152,   154,   670,   154,   154,   154,   154,     9,   154,
     152,   138,    46,   138,   138,    86,    56,   153,   153,   153,
      98,    45,   127,   154,    64,   141,   105,     6,     6,   141,
     141,   154,  1016,   154,   717,   141,   137,     9,    89,    79,
     138,   132,   138,   614,   152,     9,   141,    81,   619,   732,
     138,    91,    92,    93,    57,    63,     9,    96,   152,    46,
     153,   153,   152,     9,   153,   636,   637,   154,   153,   109,
     154,    28,     9,   113,   123,    75,    89,   117,   118,   119,
     153,     6,   141,   133,   154,   153,     9,    20,   771,   129,
     154,     9,   138,   652,    81,   654,   152,   668,    28,    75,
     134,   135,   136,    57,    28,    60,   789,   141,   142,   143,
     144,   145,   146,   147,   148,    64,   154,   676,   801,   154,
      64,    64,   789,   154,     6,    28,   153,   152,   811,    89,
     153,   690,   153,   692,   153,    46,   154,   820,   154,   698,
     152,   824,   152,     6,   153,     6,   480,   134,   135,   136,
     154,   965,   723,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   845,   272,   802,   709,   341,   866,   867,   852,
      81,   972,   867,   465,   973,   987,   733,   944,   845,   862,
     751,   752,  1021,   866,   867,   868,   678,   511,   953,   760,
     761,   801,   852,   764,   557,   878,   915,   668,   863,   866,
     867,   824,    18,   364,    -1,   845,   338,   652,   779,    -1,
     654,   878,    -1,   354,    -1,    -1,   933,    -1,    -1,    -1,
      -1,    -1,    -1,   134,   135,    -1,   909,    -1,    -1,    -1,
     801,   142,   143,   144,   145,   146,   147,   148,    -1,    -1,
     811,    -1,   909,   802,    -1,    -1,    -1,    -1,    -1,    -1,
     933,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   933,    -1,
      46,   944,    -1,    -1,    -1,   964,   837,    -1,    -1,    -1,
      -1,   842,    -1,   844,    -1,    -1,   847,    -1,    -1,    -1,
      -1,   964,   965,   854,   967,    -1,    -1,   970,    -1,   972,
      -1,    -1,   863,    -1,    -1,    81,    -1,   964,    -1,    -1,
     967,    -1,    -1,   970,   987,   972,    -1,    -1,    -1,    -1,
      -1,   882,    -1,    -1,    -1,    -1,    -1,  1000,  1001,  1002,
     987,    -1,    -1,    -1,    -1,    -1,  1009,  1010,    -1,    -1,
      -1,   902,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1022,
      -1,   912,  1009,  1010,    -1,    -1,    -1,    -1,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,     3,     4,     5,     6,     7,   154,     9,
      10,    11,   943,    -1,    -1,    -1,    16,    17,    18,    19,
      -1,    21,    22,    23,    24,    25,    26,    27,   959,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    -1,    -1,    47,    -1,    -1,
      -1,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    -1,    -1,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    -1,    -1,    88,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,   104,    -1,   106,   107,   108,   109,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
     130,   131,   132,   133,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   145,   146,    -1,    -1,    -1,
      -1,    -1,    -1,   153,    -1,   155,     3,     4,     5,     6,
       7,    -1,     9,    10,    -1,    -1,    -1,    -1,    -1,    16,
      17,    18,    19,    -1,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    -1,    -1,
      47,    -1,    -1,    -1,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    61,    -1,    63,    64,    -1,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    -1,    -1,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    -1,
      -1,    88,    -1,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,    -1,   106,
     107,   108,   109,   110,   111,   112,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,   130,   131,   132,   133,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   153,   154,   155,     3,
       4,     5,     6,     7,    -1,     9,    10,    -1,    -1,    -1,
      -1,    -1,    16,    17,    18,    19,    -1,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    -1,    -1,    47,    -1,    -1,    -1,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    -1,    -1,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    -1,    -1,    88,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,    -1,   106,   107,   108,   109,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,   130,   131,   132,   133,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   145,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   153,
     154,   155,     3,     4,     5,     6,     7,    -1,     9,    10,
      -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,    -1,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    -1,    -1,    47,    -1,    -1,    -1,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    63,    64,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    -1,    -1,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    -1,    -1,    88,    -1,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,   104,    -1,   106,   107,   108,   109,   110,
     111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,   130,
     131,   132,   133,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   145,   146,    -1,    -1,    -1,    -1,
      -1,    -1,   153,    -1,   155,     3,     4,     5,     6,     7,
      -1,     9,    10,    -1,    -1,    -1,    -1,    -1,    16,    17,
      18,    19,    -1,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    -1,    -1,    47,
      -1,    -1,    -1,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    -1,    -1,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    -1,    -1,
      88,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,   104,    -1,   106,   107,
     108,   109,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,   130,   131,   132,   133,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   145,   146,    -1,
      -1,    -1,    -1,    -1,    -1,   153,    -1,   155,     3,     4,
       5,     6,     7,    -1,     9,    10,    -1,    -1,    -1,    -1,
      -1,    16,    17,    18,    19,    -1,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      -1,    -1,    47,    -1,    -1,    -1,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    63,    64,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      -1,    -1,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    -1,    -1,    88,    -1,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
      -1,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,   130,   131,   132,   133,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     145,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   153,    -1,
     155,     3,     4,     5,     6,     7,    -1,     9,    10,    -1,
      -1,    -1,    -1,    -1,    16,    17,    18,    19,    -1,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    -1,    -1,    47,    -1,    -1,    -1,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    -1,    -1,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    -1,    -1,    88,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,    -1,   106,   107,   108,   109,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,   129,   130,   131,
     132,   133,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   145,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   153,   154,   155,     3,     4,     5,     6,     7,    -1,
       9,    10,    -1,    -1,    -1,    -1,    -1,    16,    17,    18,
      19,    -1,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    -1,    -1,    47,    -1,
      -1,    -1,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    63,    64,    -1,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    -1,    -1,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    -1,    -1,    88,
      -1,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,    -1,   106,   107,   108,
     109,   110,   111,   112,   113,   114,    -1,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,   130,   131,   132,   133,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   153,    -1,   155,     3,     4,     5,
       6,     7,    -1,     9,    10,    -1,    -1,    -1,    -1,    -1,
      16,    17,    18,    19,    -1,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    -1,
      -1,    47,    -1,    -1,    -1,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    -1,
      -1,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      -1,    -1,    88,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,   104,    -1,
     106,   107,   108,   109,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,   129,   130,   131,   132,   133,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   145,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   153,    -1,   155,
       3,     4,     5,     6,     7,    -1,     9,    10,    -1,    -1,
      -1,    -1,    -1,    16,    17,    18,    19,    -1,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    -1,    -1,    47,    -1,    -1,    -1,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    -1,    -1,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    -1,    -1,    88,    -1,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,    -1,   106,   107,   108,   109,   110,   111,   112,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,   130,   131,   132,
     133,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   145,     3,     4,     5,     6,    -1,    -1,    -1,
     153,    -1,   155,    -1,    -1,    -1,    -1,    17,    18,    19,
      -1,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    -1,    -1,    47,    -1,    49,
      -1,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    -1,    64,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    -1,    -1,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    -1,    -1,    88,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,   104,    -1,   106,   107,   108,   109,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
     130,   131,   132,   133,    -1,    -1,     3,     4,     5,     6,
      -1,    -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,    -1,
      17,    18,    19,   153,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    -1,    -1,
      47,    -1,    49,    -1,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    61,    -1,    -1,    64,    -1,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    -1,    -1,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    -1,
      -1,    88,    -1,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,    -1,   106,
     107,   108,   109,   110,   111,   112,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,   130,   131,   132,   133,    -1,    -1,     3,
       4,     5,     6,    -1,    -1,    -1,    -1,    -1,   145,    -1,
      -1,    -1,    -1,    17,    18,    19,   153,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    -1,    -1,    47,    -1,    49,    -1,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    -1,
      64,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    -1,    -1,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    -1,    -1,    88,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,    -1,   106,   107,   108,   109,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,   130,   131,   132,   133,
      -1,    -1,     3,     4,    -1,     6,    -1,    -1,     9,    -1,
      -1,   145,    -1,    -1,    -1,    -1,    17,    18,    19,   153,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    -1,    -1,    47,    -1,    -1,    -1,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    -1,    64,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    -1,    -1,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    -1,    -1,    88,    -1,    90,
      91,    92,    93,    94,    95,    96,    -1,    98,    -1,   100,
     101,   102,   103,   104,    -1,   106,   107,   108,   109,   110,
     111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,   130,
     131,   132,   133,    -1,    -1,     3,     4,    -1,    -1,    -1,
      -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    17,
      18,    19,   153,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    -1,    -1,    47,
      -1,    -1,    -1,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    -1,    64,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    -1,    -1,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    -1,    -1,
      88,    -1,    90,    91,    92,    93,    94,    95,    96,    -1,
      98,    -1,   100,   101,   102,   103,   104,    -1,   106,   107,
     108,   109,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,   130,   131,   132,   133,    -1,    -1,     3,     4,
      -1,     6,    -1,    -1,     9,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    18,    19,   153,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      -1,    -1,    47,    -1,    -1,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    -1,    64,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      -1,    -1,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    -1,    88,    -1,    90,    91,    92,    93,    94,
      95,    96,    -1,    98,    -1,   100,   101,   102,   103,   104,
      -1,   106,   107,   108,   109,   110,   111,   112,   113,   114,
      -1,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,    -1,   127,   128,   129,   130,   131,   132,   133,     3,
       4,     5,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     145,    -1,    -1,    17,    18,    19,    -1,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    -1,    -1,    47,    -1,    49,    -1,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    -1,
      64,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    -1,    -1,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    -1,    -1,    88,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,    -1,   106,   107,   108,   109,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,   130,   131,   132,   133,
       3,     4,    -1,     6,    -1,    -1,     9,    -1,    -1,    -1,
      -1,   145,    -1,    -1,    17,    18,    19,    -1,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    -1,    -1,    47,    -1,    -1,    -1,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      -1,    64,    -1,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    -1,    -1,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    -1,    -1,    88,    -1,    90,    91,    92,
      93,    94,    95,    96,    -1,    98,    -1,   100,   101,   102,
     103,   104,    -1,   106,   107,   108,   109,   110,   111,   112,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,   130,   131,   132,
     133,     3,     4,    -1,     6,    -1,    -1,     9,    -1,    -1,
      -1,    -1,   145,    -1,    -1,    17,    18,    19,    -1,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    -1,    -1,    47,    -1,    -1,    -1,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    -1,    64,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    -1,    -1,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    -1,    -1,    88,    -1,    90,    91,
      92,    93,    94,    95,    96,    -1,    98,    -1,   100,   101,
     102,   103,   104,    -1,   106,   107,   108,   109,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,   129,   130,   131,
     132,   133,     3,     4,    -1,     6,     7,    -1,     9,    -1,
      -1,    -1,    -1,   145,    -1,    -1,    17,    18,    19,    -1,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    -1,    -1,    47,    -1,    -1,    -1,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    -1,    64,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    -1,    -1,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    -1,    88,    -1,    90,
      91,    92,    93,    94,    95,    96,    -1,    98,    -1,   100,
     101,   102,   103,   104,    -1,   106,   107,   108,   109,   110,
     111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,   130,
     131,   132,   133,     3,     4,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      -1,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    -1,    -1,    47,    -1,    -1,
      -1,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    -1,    -1,    88,    -1,
      90,    91,    92,    93,    94,    95,    96,    -1,    98,    -1,
     100,   101,   102,   103,   104,    -1,   106,   107,   108,   109,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
     130,   131,   132,   133,     3,     4,     5,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    -1,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    -1,    -1,    47,    -1,
      49,    -1,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    -1,    64,    -1,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    -1,    -1,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    -1,    -1,    88,
      -1,    90,    91,    92,    93,    94,    95,    96,    -1,    98,
      -1,   100,   101,   102,   103,   104,    -1,   106,   107,   108,
     109,   110,   111,   112,   113,   114,    -1,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,   130,   131,   132,   133,     3,     4,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      18,    19,    -1,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    -1,    -1,    47,
      -1,    49,    -1,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    -1,    64,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    -1,    -1,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    -1,    -1,
      88,    -1,    90,    91,    92,    93,    94,    95,    96,    -1,
      98,    -1,   100,   101,   102,   103,   104,    -1,   106,   107,
     108,   109,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,   130,   131,   132,   133,     3,     4,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    -1,    -1,
      47,    -1,    -1,    -1,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    61,    -1,    -1,    64,    -1,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    -1,    -1,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    -1,
      -1,    88,    -1,    90,    91,    92,    93,    94,    95,    96,
      -1,    98,    -1,   100,   101,   102,   103,   104,    -1,   106,
     107,   108,   109,   110,   111,   112,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,   130,   131,   132,   133,     3,     4,    -1,
      -1,    -1,    -1,     9,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    17,    18,    19,    -1,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    -1,
      -1,    47,    -1,    -1,    -1,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    -1,    64,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    -1,
      -1,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      -1,    -1,    88,    -1,    90,    91,    92,    93,    94,    95,
      96,    -1,    98,    -1,   100,   101,   102,   103,   104,    -1,
     106,   107,   108,   109,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,   129,   130,   131,   132,   133,     3,     4,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    18,    19,    -1,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      -1,    -1,    47,    -1,    -1,    -1,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    -1,    64,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    -1,    -1,    88,    -1,    90,    91,    92,    93,    94,
      95,    96,    -1,    98,    -1,   100,   101,   102,   103,   104,
      -1,   106,   107,   108,   109,   110,   111,   112,   113,   114,
      -1,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,   130,   131,   132,   133,     3,
       4,    -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    17,    18,    19,    -1,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    -1,    -1,    47,    -1,    -1,    -1,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    -1,
      64,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    -1,    -1,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    -1,    -1,    88,    -1,    90,    91,    92,    93,
      94,    95,    96,    -1,    98,    -1,   100,   101,   102,   103,
     104,    -1,   106,   107,   108,   109,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,   130,   131,   132,   133,
       3,     4,    -1,    -1,    -1,    -1,    -1,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    17,    18,    19,    -1,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    -1,    -1,    47,    -1,    -1,    -1,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      -1,    64,    -1,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    -1,    -1,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    -1,    -1,    88,    -1,    90,    91,    92,
      93,    94,    95,    96,    -1,    98,    -1,   100,   101,   102,
     103,   104,    -1,   106,   107,   108,   109,   110,   111,   112,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,   130,   131,   132,
     133,     3,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    17,    18,    19,    -1,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    -1,    -1,    47,    -1,    -1,    -1,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    -1,    64,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    -1,    -1,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    -1,    -1,    88,    -1,    90,    91,
      92,    93,    94,    95,    96,    -1,    98,    -1,   100,   101,
     102,   103,   104,    -1,   106,   107,   108,   109,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,   129,   130,   131,
     132,   133,     3,     4,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,    -1,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    -1,    -1,    47,    -1,    -1,    -1,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    -1,    64,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    -1,    -1,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    -1,    -1,    88,    -1,    90,
      91,    92,    93,    94,    95,    96,    -1,    98,    -1,   100,
     101,   102,   103,   104,    -1,   106,   107,   108,   109,   110,
     111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,   130,
     131,   132,   133,     3,     4,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      -1,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    -1,    -1,    47,    -1,    -1,
      -1,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    -1,    64,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    -1,    -1,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    -1,    -1,    88,    -1,
      90,    91,    92,    93,    94,    95,    96,    -1,    98,    -1,
     100,   101,   102,   103,   104,    -1,   106,   107,   108,   109,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
     130,   131,   132,   133,     3,     4,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    -1,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    -1,    -1,    47,    -1,
      -1,    -1,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    -1,    64,    -1,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    -1,    -1,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    -1,    -1,    88,
      -1,    90,    91,    92,    93,    94,    95,    96,    -1,    98,
      -1,   100,   101,   102,   103,   104,    -1,   106,   107,   108,
     109,   110,   111,   112,   113,   114,    -1,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,   130,   131,   132,   133,     3,     4,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      18,    19,    -1,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    -1,    -1,    47,
      -1,    -1,    -1,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    -1,    64,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    -1,    -1,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    -1,
      98,    -1,   100,   101,   102,   103,   104,    -1,   106,   107,
     108,   109,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,     3,   127,
     128,   129,   130,   131,   132,   133,    11,    -1,    -1,    -1,
      -1,    -1,    17,    18,    19,    -1,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    32,    -1,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      -1,    -1,    47,    -1,    -1,    -1,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    -1,    64,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      -1,    -1,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    -1,    -1,    88,    -1,    90,    91,    92,    93,    94,
      95,    96,    -1,    98,    -1,   100,   101,   102,   103,   104,
      -1,   106,   107,   108,   109,   110,   111,   112,   113,   114,
      -1,   116,   117,   118,   119,   120,    -1,    -1,   123,   124,
     125,    -1,   127,   128,   129,   130,   131,   132,   133,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    17,    18,    19,    -1,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    32,    -1,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    -1,    -1,    47,    -1,    -1,    -1,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    -1,
      64,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    -1,    -1,    77,    78,    79,    80,    -1,    82,    83,
      -1,    -1,    -1,    -1,    88,    -1,    90,    91,    92,    93,
      94,    95,    96,    -1,    98,    -1,   100,   101,   102,   103,
     104,    -1,   106,   107,   108,   109,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,     3,   127,   128,   129,   130,   131,   132,   133,
      11,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,    -1,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    32,    -1,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    -1,    -1,    47,    -1,    -1,    46,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    -1,    64,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    -1,    -1,    77,    78,    79,    80,
      -1,    82,    83,    84,    81,    46,    -1,    88,    -1,    90,
      91,    92,    93,    94,    95,    96,    -1,    98,    -1,   100,
     101,   102,   103,   104,    -1,   106,   107,   108,   109,   110,
     111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
      81,    46,   123,   124,   125,    -1,   127,   128,   129,   130,
     131,   132,   133,    -1,    -1,    -1,    -1,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,    -1,    46,    -1,   152,    81,   154,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,    81,    46,
      -1,   152,    -1,   154,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,    81,    46,    -1,    -1,    -1,   154,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,    -1,    46,    -1,    -1,
      81,   154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,    81,    46,    -1,    -1,    -1,   154,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,    81,    46,
      -1,    -1,    -1,   154,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    46,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
      -1,    46,    -1,    -1,    81,   154,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,
      46,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,    81,    -1,    -1,   152,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    81,    -1,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   134,   135,   136,   152,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,    -1,    46,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,    -1,    -1,    -1,   152,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,    81,    22,    -1,   152,    25,    -1,    -1,
      -1,    29,    -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,
      46,    -1,    -1,    41,    42,    43,    44,    53,    -1,    -1,
      48,    -1,    -1,    -1,    52,    -1,    46,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    81,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,    81,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    99,    -1,   101,    -1,   103,    -1,   105,    -1,   107,
      -1,    -1,   110,    -1,   112,    -1,    -1,   115,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   123,    -1,   125,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,    -1,   134,   135,   136,    -1,    -1,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    22,    25,    29,    36,    41,    42,    43,    44,    48,
      52,    67,    90,    99,   101,   103,   105,   107,   110,   112,
     115,   123,   125,   160,   161,   184,   185,   186,   187,   194,
     243,   247,   249,   254,   255,   256,   257,   265,   267,   276,
     278,   279,   287,   290,   292,   293,   294,   295,   296,   297,
     301,   302,   305,   307,   322,   323,   324,   325,   326,    64,
       3,     4,    17,    18,    19,    21,    22,    23,    24,    25,
      26,    27,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    42,    43,    44,    47,    51,    52,
      53,    56,    57,    58,    59,    60,    61,    64,    66,    67,
      68,    69,    70,    72,    73,    74,    77,    78,    79,    80,
      82,    83,    84,    88,    90,    91,    92,    93,    94,    95,
      96,    98,   100,   101,   102,   103,   104,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   116,   117,   118,   119,
     120,   121,   123,   124,   125,   127,   128,   129,   130,   131,
     132,   133,   162,   163,   164,    32,   266,   327,    23,    61,
      76,    95,   104,   306,    64,    65,    92,     3,     5,     6,
       7,     9,    10,    11,    16,    18,    19,    24,    27,    38,
      47,    51,    58,    59,    63,    66,    69,    78,    80,    85,
      94,    97,   102,   116,   130,   145,   146,   153,   155,   164,
     182,   196,   197,   199,   235,   236,   239,   298,   299,   300,
     308,   309,   312,   313,    30,    32,    56,    64,    84,   109,
     163,   182,   288,    17,    30,    34,    39,    40,    56,    64,
      79,    91,    92,    93,   109,   113,   117,   118,   119,   129,
     245,   246,   288,   121,     5,     6,    18,    19,    27,    38,
      47,    49,    58,    69,    97,   130,   145,   153,   164,   205,
     206,   207,   208,   209,   309,   104,   117,   303,   280,     0,
     150,    49,   150,   320,    70,     4,    33,    84,   121,   163,
     164,   166,   167,   168,   176,     4,    33,    84,   121,   163,
     166,   153,   164,    55,   164,   166,   166,    64,   166,    55,
     153,    14,    16,   171,   172,   180,   181,   153,   153,   153,
     153,   153,   153,   153,   153,   153,   153,   153,     3,    78,
      80,   235,   153,   153,   153,   153,   153,   235,   235,    63,
      75,   164,   240,   241,    14,    15,    16,   157,   310,   311,
      55,   152,    20,   164,   198,    46,    81,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   153,    75,   152,   224,   225,   198,    63,    71,
     141,   107,   164,    10,   163,   166,     6,     7,     9,    86,
     164,   252,   253,   141,   141,   121,     9,   113,   168,   107,
     117,    74,   244,   244,   244,   244,    88,   226,   227,   113,
     167,   168,   177,   179,   128,   153,   153,   153,   153,   153,
     153,   153,   153,   153,   153,     6,   205,   137,   138,    18,
      19,    26,    63,    71,    85,   134,   135,   136,   141,   142,
     143,    26,    63,    85,   134,   135,   136,   141,   142,   143,
     136,   141,   168,   177,   235,   317,   318,   319,   105,   107,
     185,   168,   151,    14,    16,    31,   169,   172,   173,   117,
     277,   120,     7,     9,    16,   145,   153,   209,   210,   211,
     264,   268,   269,   177,   164,   166,    55,   321,   111,     9,
     153,   154,   235,   237,   238,   180,    14,   171,    16,   235,
     237,    45,   146,   237,   237,   154,   235,   237,   237,   235,
     235,   153,   153,   153,   154,   237,   237,   235,   235,   154,
     154,   152,   156,   141,     9,   235,   311,    11,   153,   168,
     178,   179,   183,   197,   235,   164,   235,   235,   235,   235,
     235,   235,   235,   235,   235,   235,   313,   235,   235,   235,
     235,   235,   235,   235,   235,     6,   299,   153,    85,    86,
     235,   252,    56,   141,   141,    56,    33,   145,   248,     9,
      50,    86,   122,   164,   209,   250,   251,   252,    72,   113,
     244,   113,   166,     9,     4,    33,    84,   121,   162,   165,
     228,   229,   244,   152,   169,   170,   108,   113,   152,   131,
     244,   283,   284,   164,   164,   164,   309,   146,   309,   154,
     154,   309,   164,   308,   309,   154,   154,   205,   205,   153,
     153,   209,   210,    10,   153,    85,    86,    18,    19,    26,
      63,   209,   210,   209,   210,     9,   210,   251,     9,   210,
     251,   209,   210,   209,   210,   209,   153,    26,    63,   209,
     209,   209,   209,   209,   209,   209,   209,   132,   304,   107,
     198,    28,   152,   315,   316,   153,   258,   166,     6,   172,
     244,   104,   211,     9,   154,   209,   212,   270,   152,   271,
     131,   202,     9,   226,     9,     9,   105,   187,   152,   154,
     180,   154,   154,   164,   154,   154,   154,   154,   154,   154,
     152,   154,   152,   154,   235,   235,   154,   154,   152,   154,
     241,     9,   164,   209,   242,   158,   158,   169,   173,   191,
     169,   170,   171,   173,   174,   175,   195,    53,    87,   152,
     237,    86,     9,   153,   209,   250,    10,   252,   253,    73,
     244,   244,   141,   152,   167,   169,   244,   167,   164,   285,
     286,   154,   154,   154,   154,   154,   154,   152,     9,   213,
     213,   138,   138,   212,   213,    86,   153,   153,   209,    10,
     153,   138,   212,   209,   153,    98,   164,   281,   282,   309,
     317,    45,   314,   319,   164,   259,   260,   127,   166,   152,
     154,   152,   154,   264,   269,   272,   273,   154,    77,   153,
     203,   204,   205,   226,   226,   154,   238,   154,   235,   235,
     235,   141,   105,   194,   170,   201,   202,   164,     6,     6,
     154,   141,   212,   141,    96,   100,   106,   289,     6,     9,
     153,   164,   229,   141,   137,     9,   152,   154,   154,   209,
     210,   209,   210,   154,   154,   213,   213,   138,   212,   213,
     209,   154,   138,   212,   141,   152,   202,   141,   164,    89,
     220,   221,   152,   154,   153,   261,   262,   132,   291,   209,
       9,    20,   274,   152,   153,    77,   138,   138,   152,   188,
     154,   154,   152,   242,   196,   154,    57,   214,    63,   209,
     250,   154,   153,    37,   124,    96,   164,   230,   231,   153,
       9,   286,   154,     9,   154,   154,   209,   154,   154,   209,
     154,     9,   153,   209,   210,   282,   226,   209,   210,    28,
     224,   259,   153,   263,   264,   152,   226,   123,    75,   164,
     275,   264,   273,     9,   153,   205,   204,     6,   164,   189,
     190,   154,   153,    55,    89,   192,     6,   215,   133,   218,
     219,   308,   212,   141,   152,   154,     9,   154,   212,    54,
      62,   126,   232,   233,   234,    94,   207,   222,   223,   152,
     154,   262,   154,     9,   138,   152,   237,    28,    75,   193,
      28,    57,    60,   217,   154,   154,   209,   231,   154,   154,
      64,    64,    64,   234,   153,    21,    43,   152,   264,   154,
     205,   190,   154,   222,     6,   207,   216,    89,   206,   220,
     153,   153,   153,   154,   223,   154,   152,    87,   152,   152,
      28,   224,   164,   200,   200,   200,   153,     6,     6,   207,
     222,   226,   152,   154,   154,   154,   237,   232,   164,   154,
     154
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   159,   160,   160,   160,   160,   161,   161,   161,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   161,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   161,   161,
     161,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   163,   163,
     164,   164,   164,   164,   164,   165,   165,   165,   165,   165,
     166,   166,   166,   166,   166,   167,   167,   168,   169,   169,
     170,   170,   171,   172,   172,   173,   173,   174,   174,   175,
     175,   175,   176,   176,   177,   177,   177,   178,   178,   178,
     179,   179,   180,   180,   181,   181,   181,   181,   181,   182,
     182,   183,   183,   183,   184,   184,   184,   185,   185,   185,
     186,   186,   187,   187,   188,   188,   189,   189,   190,   190,
     191,   192,   193,   193,   193,   193,   195,   194,   196,   196,
     197,   197,   198,   198,   198,   199,   199,   199,   199,   199,
     199,   199,   199,   199,   200,   200,   201,   201,   202,   203,
     203,   203,   203,   203,   204,   204,   205,   205,   205,   205,
     206,   206,   206,   206,   206,   206,   206,   206,   206,   206,
     206,   206,   206,   206,   206,   206,   206,   206,   206,   206,
     206,   206,   206,   206,   206,   206,   206,   206,   206,   206,
     206,   206,   206,   206,   206,   206,   206,   206,   206,   206,
     206,   206,   206,   206,   207,   207,   207,   207,   207,   207,
     207,   207,   207,   207,   208,   208,   209,   209,   210,   210,
     211,   211,   212,   212,   213,   213,   214,   214,   215,   215,
     216,   216,   217,   217,   218,   218,   219,   220,   220,   221,
     221,   222,   222,   223,   223,   223,   224,   224,   225,   225,
     225,   226,   226,   227,   228,   228,   229,   229,   229,   229,
     229,   229,   230,   230,   231,   232,   232,   233,   233,   234,
     234,   234,   235,   235,   235,   235,   235,   235,   235,   235,
     235,   235,   235,   235,   235,   235,   235,   235,   235,   235,
     235,   235,   235,   235,   235,   235,   235,   235,   235,   235,
     235,   235,   235,   235,   236,   236,   236,   236,   236,   236,
     236,   236,   236,   236,   236,   236,   236,   236,   236,   236,
     237,   237,   238,   238,   239,   239,   239,   240,   240,   240,
     241,   241,   241,   242,   242,   242,   243,   244,   244,   245,
     245,   245,   245,   245,   245,   245,   245,   245,   245,   245,
     245,   245,   245,   245,   245,   245,   245,   245,   246,   246,
     247,   247,   247,   247,   247,   247,   248,   248,   249,   249,
     249,   249,   249,   249,   250,   250,   251,   251,   251,   252,
     252,   253,   253,   253,   253,   253,   254,   254,   254,   255,
     255,   256,   257,   257,   258,   258,   259,   260,   260,   261,
     261,   262,   263,   263,   264,   264,   264,   264,   264,   266,
     265,   267,   268,   268,   269,   269,   270,   270,   271,   271,
     272,   272,   273,   274,   274,   275,   275,   276,   277,   277,
     278,   278,   280,   279,   281,   281,   282,   282,   282,   282,
     282,   282,   282,   283,   283,   284,   285,   285,   286,   287,
     288,   288,   288,   289,   289,   289,   289,   290,   291,   291,
     292,   293,   294,   295,   296,   297,   298,   298,   299,   300,
     301,   302,   303,   303,   304,   304,   306,   305,   307,   308,
     308,   309,   310,   310,   311,   311,   311,   311,   311,   312,
     312,   313,   314,   314,   314,   315,   315,   316,   317,   318,
     319,   319,   320,   321,   321,   322,   323,   324,   325,   327,
     326
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     1,     2,
       1,     2,     1,     1,     2,     1,     2,     1,     2,     0,
       1,     1,     1,     2,     1,     2,     1,     2,     1,     1,
       3,     3,     1,     2,     1,     1,     2,     2,     3,     1,
       2,     1,     2,     2,     1,     3,     2,     1,     1,     1,
       1,     8,     1,     9,     0,     2,     1,     3,     1,     1,
       0,     3,     0,     2,     4,     4,     0,    13,     1,     3,
       1,     2,     0,     1,     2,     1,     4,     4,     4,     4,
       4,     4,     3,     5,     1,     3,     0,     1,     2,     1,
       1,     3,     3,     5,     4,     6,     1,     3,     3,     3,
       3,     3,     5,     6,     5,     6,     5,     6,     5,     6,
       3,     4,     5,     6,     3,     3,     3,     3,     3,     3,
       5,     5,     5,     3,     3,     3,     3,     3,     3,     3,
       4,     3,     3,     3,     3,     5,     6,     5,     6,     3,
       3,     3,     3,     6,     1,     1,     4,     3,     3,     1,
       4,     4,     4,     3,     4,     4,     1,     2,     1,     2,
       1,     1,     1,     3,     1,     3,     0,     4,     0,     1,
       1,     3,     0,     2,     0,     1,     5,     0,     1,     3,
       5,     1,     3,     1,     2,     2,     0,     1,     2,     4,
       4,     0,     1,     2,     1,     3,     1,     3,     3,     5,
       6,     3,     1,     3,     3,     0,     1,     1,     2,     5,
       5,     5,     1,     1,     1,     1,     1,     1,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       1,     1,     3,     4,     4,     4,     5,     4,     4,     4,
       4,     3,     6,     6,     3,     8,    14,     3,     4,     4,
       1,     3,     1,     1,     1,     1,     1,     0,     3,     5,
       1,     1,     1,     1,     1,     1,     3,     0,     2,     1,
       2,     2,     3,     1,     1,     1,     1,     3,     4,     4,
       4,     3,     3,     1,     2,     2,     2,     3,     1,     1,
       4,     4,     4,     4,     4,     4,     0,     2,     7,     5,
       5,     9,     7,     7,     1,     1,     1,     1,     1,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     7,     1,     1,     0,     3,     1,     1,     3,     1,
       3,     3,     1,     3,     1,     1,     1,     3,     2,     0,
       6,     6,     1,     3,     1,     3,     1,     3,     0,     2,
       1,     3,     3,     0,     1,     1,     1,     4,     0,     1,
       1,     1,     0,     8,     1,     3,     3,     3,     5,     4,
       3,     3,     3,     1,     1,     2,     1,     3,     3,     6,
       0,     1,     1,     2,     2,     2,     1,     7,     0,     2,
       3,     3,     2,     2,     2,     3,     1,     3,     2,     1,
       2,     4,     1,     1,     0,     2,     0,     5,     5,     1,
       1,     2,     1,     2,     1,     1,     1,     3,     3,     3,
       3,     1,     0,     1,     2,     0,     2,     1,     2,     1,
       1,     3,     6,     0,     2,     4,     2,     2,     3,     0,
       6
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (pParser, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, pParser); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, SqlParser_c * pParser)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (pParser);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, SqlParser_c * pParser)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, pParser);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, SqlParser_c * pParser)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], pParser);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, pParser); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, SqlParser_c * pParser)
{
  YY_USE (yyvaluep);
  YY_USE (pParser);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (SqlParser_c * pParser)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, pParser);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* request: statement  */
#line 187 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                        { pParser->PushQuery(); }
#line 3602 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 3: /* request: statement ';'  */
#line 188 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { pParser->PushQuery(); }
#line 3608 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 28: /* statement: TOK_DEBUGCLAUSE  */
#line 216 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                { pParser->m_pStmt->m_eStmt = STMT_DEBUG; }
#line 3614 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 130: /* identidx: "`identifier`"  */
#line 279 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
        {
		yyval = yyvsp[0];
		++yyval.m_iStart;
		--yyval.m_iEnd;
	}
#line 3624 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 136: /* one_index: ident ':' identidx  */
#line 290 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->ToString (pParser->m_pStmt->m_sCluster, yyvsp[-2]);
			yyval = yyvsp[0];
		}
#line 3633 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 137: /* only_one_index: one_index  */
#line 298 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->ToString (pParser->m_pStmt->m_sIndex, yyvsp[0]);
		}
#line 3641 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 138: /* chunk_key: ".number"  */
#line 305 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->AddDotIntSubkey (yyvsp[0]);
			pParser->m_pStmt->m_iIntParam = yyvsp[0].m_iValue;
		}
#line 3650 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 139: /* chunk_key: TOK_CHUNK "integer"  */
#line 310 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->AddIntSubkey (yyvsp[0]);
			pParser->m_pStmt->m_iIntParam = yyvsp[0].m_iValue;
		}
#line 3659 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 142: /* string_key: TOK_SUBKEY  */
#line 323 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
    		pParser->AddStringSubkey (yyvsp[0]);
    	}
#line 3667 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 156: /* one_index_opt_chunk: list_of_indexes  */
#line 359 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
        {
    		pParser->ToString (pParser->m_pQuery->m_sIndexes, yyvsp[0]);
    	}
#line 3675 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 157: /* from_target: only_one_index fromkeys  */
#line 366 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pQuery->m_sIndexes = pParser->m_pStmt->m_sIndex;
			pParser->SwapSubkeys();
		}
#line 3684 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 158: /* from_target: list_of_indexes  */
#line 371 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->ToString (pParser->m_pQuery->m_sIndexes, yyvsp[0]);
		}
#line 3692 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 159: /* from_target: sysvar_ext  */
#line 375 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
    		pParser->ToString (pParser->m_pQuery->m_sIndexes, yyvsp[0]);
    		pParser->SwapSubkeys();
    	}
#line 3701 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 160: /* list_of_indexes: one_index ',' one_index  */
#line 383 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
    		TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] );
    	}
#line 3709 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 161: /* list_of_indexes: list_of_indexes ',' one_index  */
#line 387 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] );
		}
#line 3717 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 163: /* string_nokeys: string_keys TOK_SUBKEY  */
#line 398 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			yyval = yyvsp[0];
		}
#line 3725 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 166: /* multi_strings_and_maybe_chunk_nokey: ".number" string_nokeys  */
#line 407 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
    		yyval = yyvsp[0];
    	}
#line 3733 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 167: /* multi_strings_and_maybe_chunk_nokey: string_nokeys ".number"  */
#line 411 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
        {
    		yyval = yyvsp[0];
    	}
#line 3741 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 168: /* multi_strings_and_maybe_chunk_nokey: string_nokeys ".number" string_nokeys  */
#line 415 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
        {
    		yyval = yyvsp[0];
    	}
#line 3749 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 170: /* sysvar: "@@sysvar" multi_strings_and_maybe_chunk_nokey  */
#line 423 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			TRACK_BOUNDS ( yyval, yyvsp[-1], yyvsp[0] );
		}
#line 3757 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 174: /* multi_stmt_list: multi_stmt  */
#line 438 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                                        { pParser->PushQuery(); }
#line 3763 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 175: /* multi_stmt_list: multi_stmt_list ';' multi_stmt  */
#line 439 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { pParser->PushQuery(); }
#line 3769 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 176: /* multi_stmt_list: multi_stmt_list facet_stmt  */
#line 440 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { pParser->PushQuery(); }
#line 3775 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 181: /* select: TOK_SELECT "identifier" '(' '(' select1 ')' opt_tablefunc_args ')'  */
#line 452 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			assert ( pParser->m_pStmt->m_eStmt==STMT_SELECT ); // set by table argument
			pParser->ToString ( pParser->m_pStmt->m_sTableFunc, yyvsp[-6] );
		}
#line 3784 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 183: /* select1: TOK_SELECT select_items_list TOK_FROM '(' subselect_start select_from ')' opt_outer_order opt_outer_limit  */
#line 462 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			assert ( pParser->m_pStmt->m_eStmt==STMT_SELECT ); // set by subselect
		}
#line 3792 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 186: /* tablefunc_args_list: tablefunc_arg  */
#line 474 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->ToString ( pParser->m_pStmt->m_dTableFuncArgs.Add(), yyvsp[0] );
		}
#line 3800 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 187: /* tablefunc_args_list: tablefunc_args_list ',' tablefunc_arg  */
#line 478 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->ToString ( pParser->m_pStmt->m_dTableFuncArgs.Add(), yyvsp[0] );
		}
#line 3808 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 190: /* subselect_start: %empty  */
#line 489 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
        {
		CSphVector<CSphQueryItem> & dItems = pParser->m_pQuery->m_dItems;
		if ( dItems.GetLength()!=1 || dItems[0].m_sExpr!="*" )
		{
			yyerror ( pParser, "outer select list must be a single star" );
			YYERROR;
		}
		dItems.Reset();
		pParser->ResetSelect();
	}
#line 3823 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 191: /* opt_outer_order: TOK_ORDER TOK_BY order_items_list  */
#line 503 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->ToString ( pParser->m_pQuery->m_sOuterOrderBy, yyvsp[0] );
			pParser->m_pQuery->m_bHasOuter = true;
		}
#line 3832 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 193: /* opt_outer_limit: TOK_LIMIT "integer"  */
#line 512 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pQuery->m_iOuterLimit = yyvsp[0].m_iValue;
			pParser->m_pQuery->m_bHasOuter = true;
		}
#line 3841 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 194: /* opt_outer_limit: TOK_LIMIT "integer" ',' "integer"  */
#line 517 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pQuery->m_iOuterOffset = yyvsp[-2].m_iValue;
			pParser->m_pQuery->m_iOuterLimit = yyvsp[0].m_iValue;
			pParser->m_pQuery->m_bHasOuter = true;
		}
#line 3851 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 195: /* opt_outer_limit: TOK_LIMIT "integer" TOK_OFFSET "integer"  */
#line 523 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pQuery->m_iOuterLimit = yyvsp[-2].m_iValue;
			pParser->m_pQuery->m_iOuterOffset = yyvsp[0].m_iValue;
			pParser->m_pQuery->m_bHasOuter = true;
		}
#line 3861 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 196: /* $@1: %empty  */
#line 532 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                             { pParser->m_pStmt->m_eStmt = STMT_SELECT; }
#line 3867 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 200: /* select_item: '*'  */
#line 549 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                                                { pParser->AddItem ( &yyvsp[0] ); }
#line 3873 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 203: /* opt_alias: ident  */
#line 555 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                                        { pParser->AliasLastItem ( &yyvsp[0] ); }
#line 3879 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 204: /* opt_alias: TOK_AS ident  */
#line 556 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                                { pParser->AliasLastItem ( &yyvsp[0] ); }
#line 3885 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 205: /* select_expr: expr  */
#line 560 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                                        { pParser->AddItem ( &yyvsp[0] ); }
#line 3891 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 206: /* select_expr: TOK_AVG '(' expr ')'  */
#line 561 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                        { pParser->AddItem ( &yyvsp[-1], SPH_AGGR_AVG, &yyvsp[-3], &yyvsp[0] ); }
#line 3897 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 207: /* select_expr: TOK_MAX '(' expr ')'  */
#line 562 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                        { pParser->AddItem ( &yyvsp[-1], SPH_AGGR_MAX, &yyvsp[-3], &yyvsp[0] ); }
#line 3903 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 208: /* select_expr: TOK_MIN '(' expr ')'  */
#line 563 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                        { pParser->AddItem ( &yyvsp[-1], SPH_AGGR_MIN, &yyvsp[-3], &yyvsp[0] ); }
#line 3909 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 209: /* select_expr: TOK_SUM '(' expr ')'  */
#line 564 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                        { pParser->AddItem ( &yyvsp[-1], SPH_AGGR_SUM, &yyvsp[-3], &yyvsp[0] ); }
#line 3915 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 210: /* select_expr: TOK_GROUP_CONCAT '(' expr ')'  */
#line 565 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { pParser->AddItem ( &yyvsp[-1], SPH_AGGR_CAT, &yyvsp[-3], &yyvsp[0] ); }
#line 3921 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 211: /* select_expr: TOK_COUNT '(' '*' ')'  */
#line 566 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                        { if ( !pParser->AddItem ( "count(*)", &yyvsp[-3], &yyvsp[0] ) ) YYERROR; }
#line 3927 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 212: /* select_expr: TOK_GROUPBY '(' ')'  */
#line 567 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                        { if ( !pParser->AddItem ( "groupby()", &yyvsp[-2], &yyvsp[0] ) ) YYERROR; }
#line 3933 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 213: /* select_expr: TOK_COUNT '(' TOK_DISTINCT ident ')'  */
#line 568 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { if ( !pParser->AddDistinct ( &yyvsp[-1], &yyvsp[-4], &yyvsp[0] ) ) YYERROR; }
#line 3939 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 215: /* ident_list: ident_list ',' ident  */
#line 573 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                        { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 3945 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 223: /* where_expr: filter_expr TOK_AND where_item TOK_AND filter_expr  */
#line 590 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                                { pParser->FilterAnd ( yyval, yyvsp[-4], yyvsp[0] ); }
#line 3951 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 224: /* where_item: TOK_MATCH '(' "string" ')'  */
#line 595 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->SetMatch(yyvsp[-1]) )
				YYERROR;
		}
#line 3960 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 225: /* where_item: '(' TOK_MATCH '(' "string" ')' ')'  */
#line 600 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->SetMatch(yyvsp[-2]) )
				YYERROR;
		}
#line 3969 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 226: /* filter_expr: filter_item  */
#line 607 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                                        { pParser->SetOp ( yyval ); }
#line 3975 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 227: /* filter_expr: filter_expr TOK_AND filter_expr  */
#line 608 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { pParser->FilterAnd ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 3981 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 228: /* filter_expr: filter_expr TOK_OR filter_expr  */
#line 609 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { pParser->FilterOr ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 3987 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 229: /* filter_expr: '(' filter_expr ')'  */
#line 610 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                        { pParser->FilterGroup ( yyval, yyvsp[-1] ); }
#line 3993 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 230: /* filter_item: expr_ident '=' bool_or_integer_value  */
#line 617 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			CSphFilterSettings * pFilter = pParser->AddValuesFilter ( yyvsp[-2] );
			if ( !pFilter )
				YYERROR;
			pFilter->m_dValues.Add ( yyvsp[0].m_iValue );
		}
#line 4004 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 231: /* filter_item: expr_ident "!=" bool_or_integer_value  */
#line 624 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			CSphFilterSettings * pFilter = pParser->AddValuesFilter ( yyvsp[-2] );
			if ( !pFilter )
				YYERROR;
			pFilter->m_dValues.Add ( yyvsp[0].m_iValue );
			pFilter->m_bExclude = true;
		}
#line 4016 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 232: /* filter_item: expr_ident TOK_IN '(' const_list ')'  */
#line 632 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			CSphFilterSettings * pFilter = pParser->AddValuesFilter ( yyvsp[-4] );
			if ( !pFilter )
				YYERROR;
			pFilter->m_dValues = *yyvsp[-1].m_pValues;
			pFilter->m_dValues.Uniq();
		}
#line 4028 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 233: /* filter_item: expr_ident TOK_NOT TOK_IN '(' const_list ')'  */
#line 640 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			CSphFilterSettings * pFilter = pParser->AddValuesFilter ( yyvsp[-5] );
			if ( !pFilter )
				YYERROR;
			pFilter->m_dValues = *yyvsp[-1].m_pValues;
			pFilter->m_dValues.Uniq();
			pFilter->m_bExclude = true;
		}
#line 4041 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 234: /* filter_item: expr_ident TOK_IN '(' string_list ')'  */
#line 649 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddStringListFilter ( yyvsp[-4], yyvsp[-1], StrList_e::STR_IN ) )
				YYERROR;
		}
#line 4050 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 235: /* filter_item: expr_ident TOK_NOT TOK_IN '(' string_list ')'  */
#line 654 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddStringListFilter ( yyvsp[-5], yyvsp[-1], StrList_e::STR_IN, true ) )
				YYERROR;
		}
#line 4059 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 236: /* filter_item: expr_ident TOK_ANY '(' string_list ')'  */
#line 659 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddStringListFilter ( yyvsp[-4], yyvsp[-1], StrList_e::STR_ANY ) )
				YYERROR;
		}
#line 4068 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 237: /* filter_item: expr_ident TOK_NOT TOK_ANY '(' string_list ')'  */
#line 664 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddStringListFilter ( yyvsp[-5], yyvsp[-1], StrList_e::STR_ANY, true ) )
				YYERROR;
		}
#line 4077 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 238: /* filter_item: expr_ident TOK_ALL '(' string_list ')'  */
#line 669 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddStringListFilter ( yyvsp[-4], yyvsp[-1], StrList_e::STR_ALL ) )
				YYERROR;
		}
#line 4086 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 239: /* filter_item: expr_ident TOK_NOT TOK_ALL '(' string_list ')'  */
#line 674 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddStringListFilter ( yyvsp[-5], yyvsp[-1], StrList_e::STR_ALL, true ) )
				YYERROR;
		}
#line 4095 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 240: /* filter_item: expr_ident TOK_IN "@uservar"  */
#line 679 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddUservarFilter ( yyvsp[-2], yyvsp[0], false ) )
				YYERROR;
		}
#line 4104 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 241: /* filter_item: expr_ident TOK_NOT TOK_IN "@uservar"  */
#line 684 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddUservarFilter ( yyvsp[-3], yyvsp[0], true ) )
				YYERROR;
		}
#line 4113 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 242: /* filter_item: expr_ident TOK_BETWEEN const_int TOK_AND const_int  */
#line 689 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddIntRangeFilter ( yyvsp[-4], yyvsp[-2].m_iValue, yyvsp[0].m_iValue, false ) )
				YYERROR;
		}
#line 4122 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 243: /* filter_item: expr_ident TOK_NOT TOK_BETWEEN const_int TOK_AND const_int  */
#line 694 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddIntRangeFilter ( yyvsp[-5], yyvsp[-2].m_iValue, yyvsp[0].m_iValue, true ) )
				YYERROR;
		}
#line 4131 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 244: /* filter_item: expr_ident '>' const_int  */
#line 699 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddIntFilterGreater ( yyvsp[-2], yyvsp[0].m_iValue, false ) )
				YYERROR;
		}
#line 4140 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 245: /* filter_item: expr_ident '<' const_int  */
#line 704 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddIntFilterLesser ( yyvsp[-2], yyvsp[0].m_iValue, false ) )
				YYERROR;
		}
#line 4149 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 246: /* filter_item: expr_ident ">=" const_int  */
#line 709 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddIntFilterGreater ( yyvsp[-2], yyvsp[0].m_iValue, true ) )
				YYERROR;
		}
#line 4158 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 247: /* filter_item: expr_ident "<=" const_int  */
#line 714 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddIntFilterLesser ( yyvsp[-2], yyvsp[0].m_iValue, true ) )
				YYERROR;
		}
#line 4167 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 248: /* filter_item: expr_ident '=' const_float  */
#line 719 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddFloatRangeFilter ( yyvsp[-2], yyvsp[0].m_fValue, yyvsp[0].m_fValue, true ) )
				YYERROR;
		}
#line 4176 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 249: /* filter_item: expr_ident "!=" const_float  */
#line 724 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddFloatRangeFilter ( yyvsp[-2], yyvsp[0].m_fValue, yyvsp[0].m_fValue, true, true ) )
				YYERROR;
		}
#line 4185 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 250: /* filter_item: expr_ident TOK_BETWEEN const_float TOK_AND const_float  */
#line 729 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddFloatRangeFilter ( yyvsp[-4], yyvsp[-2].m_fValue, yyvsp[0].m_fValue, true ) )
				YYERROR;
		}
#line 4194 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 251: /* filter_item: expr_ident TOK_BETWEEN const_int TOK_AND const_float  */
#line 734 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddFloatRangeFilter ( yyvsp[-4], yyvsp[-2].m_iValue, yyvsp[0].m_fValue, true ) )
				YYERROR;
		}
#line 4203 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 252: /* filter_item: expr_ident TOK_BETWEEN const_float TOK_AND const_int  */
#line 739 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddFloatRangeFilter ( yyvsp[-4], yyvsp[-2].m_fValue, yyvsp[0].m_iValue, true ) )
				YYERROR;
		}
#line 4212 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 253: /* filter_item: expr_ident '>' const_float  */
#line 744 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddFloatRangeFilter ( yyvsp[-2], yyvsp[0].m_fValue, FLT_MAX, false ) )
				YYERROR;
		}
#line 4221 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 254: /* filter_item: expr_ident '<' const_float  */
#line 749 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddFloatRangeFilter ( yyvsp[-2], -FLT_MAX, yyvsp[0].m_fValue, false ) )
				YYERROR;
		}
#line 4230 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 255: /* filter_item: expr_ident ">=" const_float  */
#line 754 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddFloatRangeFilter ( yyvsp[-2], yyvsp[0].m_fValue, FLT_MAX, true ) )
				YYERROR;
		}
#line 4239 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 256: /* filter_item: expr_ident "<=" const_float  */
#line 759 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddFloatRangeFilter ( yyvsp[-2], -FLT_MAX, yyvsp[0].m_fValue, true ) )
				YYERROR;
		}
#line 4248 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 257: /* filter_item: expr_ident '=' "string"  */
#line 764 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddStringFilter ( yyvsp[-2], yyvsp[0], false ) )
				YYERROR;
		}
#line 4257 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 258: /* filter_item: expr_ident "!=" "string"  */
#line 769 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddStringFilter ( yyvsp[-2], yyvsp[0], true ) )
				YYERROR;
		}
#line 4266 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 259: /* filter_item: expr_ident TOK_IS TOK_NULL  */
#line 774 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddNullFilter ( yyvsp[-2], true ) )
				YYERROR;
		}
#line 4275 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 260: /* filter_item: expr_ident TOK_IS TOK_NOT TOK_NULL  */
#line 779 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddNullFilter ( yyvsp[-3], false ) )
				YYERROR;
		}
#line 4284 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 261: /* filter_item: const_int '=' const_int  */
#line 784 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			CSphFilterSettings * pFilter = pParser->AddValuesFilter ( yyvsp[-2] );
			if ( !pFilter )
				YYERROR;
			pFilter->m_dValues.Add ( yyvsp[0].m_iValue );
		}
#line 4295 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 262: /* filter_item: const_int "!=" const_int  */
#line 791 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			CSphFilterSettings * pFilter = pParser->AddValuesFilter ( yyvsp[-2] );
			if ( !pFilter )
				YYERROR;
			pFilter->m_dValues.Add ( yyvsp[0].m_iValue );
			pFilter->m_bExclude = true;
		}
#line 4307 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 263: /* filter_item: mva_aggr '=' const_int  */
#line 801 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			CSphFilterSettings * f = pParser->AddFilter ( yyvsp[-2], SPH_FILTER_VALUES );
			f->m_eMvaFunc = ( yyvsp[-2].m_iType==TOK_ALL ) ? SPH_MVAFUNC_ALL : SPH_MVAFUNC_ANY;
			f->m_dValues.Add ( yyvsp[0].m_iValue );
		}
#line 4317 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 264: /* filter_item: mva_aggr "!=" const_int  */
#line 807 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			// tricky bit
			// any(tags!=val) is not equivalent to not(any(tags==val))
			// any(tags!=val) is instead equivalent to not(all(tags)==val)
			// thus, along with setting the exclude flag on, we also need to invert the function
			CSphFilterSettings * f = pParser->AddFilter ( yyvsp[-2], SPH_FILTER_VALUES );
			f->m_eMvaFunc = ( yyvsp[-2].m_iType==TOK_ALL ) ? SPH_MVAFUNC_ANY : SPH_MVAFUNC_ALL;
			f->m_bExclude = true;
			f->m_dValues.Add ( yyvsp[0].m_iValue );
		}
#line 4332 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 265: /* filter_item: mva_aggr TOK_IN '(' const_list ')'  */
#line 818 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			CSphFilterSettings * f = pParser->AddFilter ( yyvsp[-4], SPH_FILTER_VALUES );
			f->m_eMvaFunc = ( yyvsp[-4].m_iType==TOK_ALL ) ? SPH_MVAFUNC_ALL : SPH_MVAFUNC_ANY;
			f->m_dValues = *yyvsp[-1].m_pValues;
			f->m_dValues.Uniq();
		}
#line 4343 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 266: /* filter_item: mva_aggr TOK_NOT TOK_IN '(' const_list ')'  */
#line 825 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			// tricky bit with inversion again
			CSphFilterSettings * f = pParser->AddFilter ( yyvsp[-5], SPH_FILTER_VALUES );
			f->m_eMvaFunc = ( yyvsp[-5].m_iType==TOK_ALL ) ? SPH_MVAFUNC_ANY : SPH_MVAFUNC_ALL;
			f->m_bExclude = true;
			f->m_dValues = *yyvsp[-1].m_pValues;
			f->m_dValues.Uniq();
		}
#line 4356 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 267: /* filter_item: mva_aggr TOK_BETWEEN const_int TOK_AND const_int  */
#line 834 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			AddMvaRange ( pParser, yyvsp[-4], yyvsp[-2].m_iValue, yyvsp[0].m_iValue );
		}
#line 4364 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 268: /* filter_item: mva_aggr TOK_NOT TOK_BETWEEN const_int TOK_AND const_int  */
#line 838 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			// tricky bit with inversion again
			CSphFilterSettings * f = pParser->AddFilter ( yyvsp[-5], SPH_FILTER_RANGE );
			f->m_eMvaFunc = ( yyvsp[-5].m_iType==TOK_ALL ) ? SPH_MVAFUNC_ANY : SPH_MVAFUNC_ALL;
			f->m_bExclude = true;
			f->m_iMinValue = yyvsp[-2].m_iValue;
			f->m_iMaxValue = yyvsp[0].m_iValue;
		}
#line 4377 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 269: /* filter_item: mva_aggr '<' const_int  */
#line 847 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			AddMvaRange ( pParser, yyvsp[-2], INT64_MIN, yyvsp[0].m_iValue-1 );
		}
#line 4385 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 270: /* filter_item: mva_aggr '>' const_int  */
#line 851 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			AddMvaRange ( pParser, yyvsp[-2], yyvsp[0].m_iValue+1, INT64_MAX );
		}
#line 4393 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 271: /* filter_item: mva_aggr "<=" const_int  */
#line 855 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			AddMvaRange ( pParser, yyvsp[-2], INT64_MIN, yyvsp[0].m_iValue );
		}
#line 4401 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 272: /* filter_item: mva_aggr ">=" const_int  */
#line 859 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			AddMvaRange ( pParser, yyvsp[-2], yyvsp[0].m_iValue, INT64_MAX );
		}
#line 4409 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 273: /* filter_item: TOK_REGEX '(' json_field ',' "string" ')'  */
#line 863 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			TRACK_BOUNDS ( yyval, yyvsp[-5], yyvsp[0] );
			CSphFilterSettings * pFilter = pParser->AddFilter ( yyval, SPH_FILTER_EXPRESSION );
			if ( !pFilter )
				YYERROR;
		}
#line 4420 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 275: /* expr_ident: TOK_ATIDENT  */
#line 874 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->SetOldSyntax() )
				YYERROR;
		}
#line 4429 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 276: /* expr_ident: TOK_COUNT '(' '*' ')'  */
#line 879 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			yyval.m_iType = SPHINXQL_TOK_COUNT;
			if ( !pParser->SetNewSyntax() )
				YYERROR;
		}
#line 4439 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 277: /* expr_ident: TOK_GROUPBY '(' ')'  */
#line 885 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			yyval.m_iType = SPHINXQL_TOK_GROUPBY;
			if ( !pParser->SetNewSyntax() )
				YYERROR;
		}
#line 4449 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 278: /* expr_ident: TOK_WEIGHT '(' ')'  */
#line 891 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			yyval.m_iType = SPHINXQL_TOK_WEIGHT;
			if ( !pParser->SetNewSyntax() )
				YYERROR;
		}
#line 4459 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 280: /* expr_ident: TOK_INTEGER '(' json_expr ')'  */
#line 897 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { TRACK_BOUNDS ( yyval, yyvsp[-3], yyvsp[0] ); }
#line 4465 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 281: /* expr_ident: TOK_DOUBLE '(' json_expr ')'  */
#line 898 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { TRACK_BOUNDS ( yyval, yyvsp[-3], yyvsp[0] ); }
#line 4471 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 282: /* expr_ident: TOK_BIGINT '(' json_expr ')'  */
#line 899 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { TRACK_BOUNDS ( yyval, yyvsp[-3], yyvsp[0] ); }
#line 4477 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 284: /* mva_aggr: TOK_ANY '(' ident ')'  */
#line 904 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                { yyval = yyvsp[-1]; yyval.m_iType = TOK_ANY; }
#line 4483 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 285: /* mva_aggr: TOK_ALL '(' ident ')'  */
#line 905 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                { yyval = yyvsp[-1]; yyval.m_iType = TOK_ALL; }
#line 4489 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 286: /* const_int: "integer"  */
#line 910 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			yyval.m_iType = TOK_CONST_INT;
			if ( (uint64_t)yyvsp[0].m_iValue > (uint64_t)LLONG_MAX )
				yyval.m_iValue = LLONG_MAX;
			else
				yyval.m_iValue = yyvsp[0].m_iValue;
		}
#line 4501 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 287: /* const_int: '-' "integer"  */
#line 918 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			yyval.m_iType = TOK_CONST_INT;
			if ( (uint64_t)yyvsp[0].m_iValue > (uint64_t)LLONG_MAX )
				yyval.m_iValue = LLONG_MIN;
			else
				yyval.m_iValue = -yyvsp[0].m_iValue;
		}
#line 4513 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 288: /* const_float: const_float_unsigned  */
#line 928 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { yyval.m_iType = TOK_CONST_FLOAT; yyval.m_fValue = yyvsp[0].m_fValue; }
#line 4519 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 289: /* const_float: '-' const_float_unsigned  */
#line 929 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { yyval.m_iType = TOK_CONST_FLOAT; yyval.m_fValue = -yyvsp[0].m_fValue; }
#line 4525 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 290: /* const_float_unsigned: "float"  */
#line 936 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { yyval.m_fValue = yyvsp[0].m_fValue; }
#line 4531 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 291: /* const_float_unsigned: ".number"  */
#line 937 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { yyval.m_fValue = pParser->ToFloat (yyvsp[0]); }
#line 4537 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 292: /* const_list: const_int  */
#line 942 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			assert ( !yyval.m_pValues );
			yyval.m_pValues = new RefcountedVector_c<SphAttr_t> ();
			yyval.m_pValues->Add ( yyvsp[0].m_iValue ); 
		}
#line 4547 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 293: /* const_list: const_list ',' const_int  */
#line 948 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			yyval.m_pValues->Add ( yyvsp[0].m_iValue );
		}
#line 4555 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 294: /* string_list: "string"  */
#line 955 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			assert ( !yyval.m_pValues );
			yyval.m_pValues = new RefcountedVector_c<SphAttr_t> ();
			yyval.m_pValues->Add ( yyvsp[0].m_iValue );
		}
#line 4565 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 295: /* string_list: string_list ',' "string"  */
#line 961 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			yyval.m_pValues->Add ( yyvsp[0].m_iValue );
		}
#line 4573 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 299: /* opt_int: "integer"  */
#line 974 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->SetGroupbyLimit ( yyvsp[0].m_iValue );
		}
#line 4581 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 300: /* group_items_list: expr_ident  */
#line 981 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->AddGroupBy ( yyvsp[0] );
		}
#line 4589 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 301: /* group_items_list: group_items_list ',' expr_ident  */
#line 985 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->AddGroupBy ( yyvsp[0] );
		}
#line 4597 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 303: /* opt_having_clause: TOK_HAVING filter_item  */
#line 993 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->AddHaving();
		}
#line 4605 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 306: /* group_order_clause: TOK_WITHIN TOK_GROUP TOK_ORDER TOK_BY order_items_list  */
#line 1005 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( pParser->m_pQuery->m_sGroupBy.IsEmpty() )
			{
				yyerror ( pParser, "you must specify GROUP BY element in order to use WITHIN GROUP ORDER BY clause" );
				YYERROR;
			}
			pParser->ToString ( pParser->m_pQuery->m_sSortBy, yyvsp[0] );
		}
#line 4618 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 309: /* order_clause: TOK_ORDER TOK_BY order_items_list  */
#line 1022 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->ToString ( pParser->m_pQuery->m_sOrderBy, yyvsp[0] );
		}
#line 4626 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 310: /* order_clause: TOK_ORDER TOK_BY TOK_RAND '(' ')'  */
#line 1026 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pQuery->m_sOrderBy = "@random";
		}
#line 4634 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 312: /* order_items_list: order_items_list ',' order_item  */
#line 1033 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4640 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 314: /* order_item: expr_ident TOK_ASC  */
#line 1038 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                        { TRACK_BOUNDS ( yyval, yyvsp[-1], yyvsp[0] ); }
#line 4646 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 315: /* order_item: expr_ident TOK_DESC  */
#line 1039 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                        { TRACK_BOUNDS ( yyval, yyvsp[-1], yyvsp[0] ); }
#line 4652 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 318: /* limit_clause: TOK_LIMIT "integer"  */
#line 1049 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->SetLimit ( 0, yyvsp[0].m_iValue );
		}
#line 4660 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 319: /* limit_clause: TOK_LIMIT "integer" ',' "integer"  */
#line 1053 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->SetLimit ( yyvsp[-2].m_iValue, yyvsp[0].m_iValue );
		}
#line 4668 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 320: /* limit_clause: TOK_LIMIT "integer" TOK_OFFSET "integer"  */
#line 1057 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->SetLimit ( yyvsp[0].m_iValue, yyvsp[-2].m_iValue );
		}
#line 4676 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 326: /* option_item: ident_no_option  */
#line 1078 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddOption ( yyvsp[0] ) )
				YYERROR;
		}
#line 4685 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 327: /* option_item: ident_no_option '=' ident  */
#line 1083 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddOption ( yyvsp[-2], yyvsp[0] ) )
				YYERROR;
		}
#line 4694 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 328: /* option_item: ident_no_option '=' "integer"  */
#line 1088 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddOption ( yyvsp[-2], yyvsp[0] ) )
				YYERROR;
		}
#line 4703 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 329: /* option_item: ident_no_option '=' '(' named_const_list ')'  */
#line 1093 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddOption ( yyvsp[-4], pParser->GetNamedVec ( yyvsp[-1].m_iValue ) ) )
				YYERROR;
			pParser->FreeNamedVec ( yyvsp[-1].m_iValue );
		}
#line 4713 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 330: /* option_item: ident_no_option '=' ident '(' "string" ')'  */
#line 1099 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddOption ( yyvsp[-5], yyvsp[-3], yyvsp[-1] ) )
				YYERROR;
		}
#line 4722 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 331: /* option_item: ident_no_option '=' "string"  */
#line 1104 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			if ( !pParser->AddOption ( yyvsp[-2], yyvsp[0] ) )
				YYERROR;
		}
#line 4731 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 332: /* named_const_list: named_const  */
#line 1112 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			yyval.m_iValue = pParser->AllocNamedVec ();
			pParser->AddConst ( yyval.m_iValue, yyvsp[0] );
		}
#line 4740 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 333: /* named_const_list: named_const_list ',' named_const  */
#line 1117 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->AddConst( yyval.m_iValue, yyvsp[0] );
		}
#line 4748 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 334: /* named_const: ident '=' const_int  */
#line 1124 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			yyval = yyvsp[-2];
			yyval.m_iValue = yyvsp[0].m_iValue;
		}
#line 4757 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 339: /* hint_item: TOK_FORCE TOK_INDEX '(' ident_list ')'  */
#line 1142 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->AddIndexHint ( INDEX_HINT_FORCE, yyvsp[-1] );
		}
#line 4765 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 340: /* hint_item: TOK_USE TOK_INDEX '(' ident_list ')'  */
#line 1146 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->AddIndexHint ( INDEX_HINT_USE, yyvsp[-1] );
		}
#line 4773 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 341: /* hint_item: TOK_IGNORE TOK_INDEX '(' ident_list ')'  */
#line 1150 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->AddIndexHint ( INDEX_HINT_IGNORE, yyvsp[-1] );
		}
#line 4781 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 343: /* expr: TOK_ATIDENT  */
#line 1160 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { if ( !pParser->SetOldSyntax() ) YYERROR; }
#line 4787 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 348: /* expr: '-' expr  */
#line 1165 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { TRACK_BOUNDS ( yyval, yyvsp[-1], yyvsp[0] ); }
#line 4793 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 349: /* expr: TOK_NOT expr  */
#line 1166 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-1], yyvsp[0] ); }
#line 4799 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 350: /* expr: expr '+' expr  */
#line 1168 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4805 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 351: /* expr: expr '-' expr  */
#line 1169 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4811 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 352: /* expr: expr '*' expr  */
#line 1170 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4817 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 353: /* expr: expr '/' expr  */
#line 1171 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4823 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 354: /* expr: expr '<' expr  */
#line 1172 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4829 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 355: /* expr: expr '>' expr  */
#line 1173 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4835 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 356: /* expr: expr '&' expr  */
#line 1174 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4841 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 357: /* expr: expr '|' expr  */
#line 1175 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4847 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 358: /* expr: expr '%' expr  */
#line 1176 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4853 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 359: /* expr: expr TOK_DIV expr  */
#line 1177 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4859 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 360: /* expr: expr TOK_MOD expr  */
#line 1178 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4865 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 361: /* expr: expr "<=" expr  */
#line 1179 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4871 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 362: /* expr: expr ">=" expr  */
#line 1180 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4877 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 363: /* expr: expr '=' expr  */
#line 1181 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4883 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 364: /* expr: expr "!=" expr  */
#line 1182 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4889 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 365: /* expr: expr TOK_AND expr  */
#line 1183 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4895 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 366: /* expr: expr TOK_OR expr  */
#line 1184 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4901 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 367: /* expr: '(' expr ')'  */
#line 1185 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4907 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 368: /* expr: '{' consthash '}'  */
#line 1186 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4913 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 372: /* expr: json_field TOK_IS TOK_NULL  */
#line 1190 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                        { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4919 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 373: /* expr: json_field TOK_IS TOK_NOT TOK_NULL  */
#line 1191 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-3], yyvsp[0] ); }
#line 4925 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 374: /* function: "identifier" '(' arglist ')'  */
#line 1195 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-3], yyvsp[0] ); }
#line 4931 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 375: /* function: TOK_IN '(' arglist ')'  */
#line 1196 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-3], yyvsp[0] ); }
#line 4937 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 376: /* function: json_field TOK_IN '(' arglist ')'  */
#line 1197 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                            { TRACK_BOUNDS ( yyval, yyvsp[-4], yyvsp[0] ); }
#line 4943 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 377: /* function: TOK_INTEGER '(' arglist ')'  */
#line 1198 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { TRACK_BOUNDS ( yyval, yyvsp[-3], yyvsp[0] ); }
#line 4949 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 378: /* function: TOK_BIGINT '(' arglist ')'  */
#line 1199 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { TRACK_BOUNDS ( yyval, yyvsp[-3], yyvsp[0] ); }
#line 4955 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 379: /* function: TOK_FLOAT '(' arglist ')'  */
#line 1200 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-3], yyvsp[0] ); }
#line 4961 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 380: /* function: TOK_DOUBLE '(' arglist ')'  */
#line 1201 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { TRACK_BOUNDS ( yyval, yyvsp[-3], yyvsp[0] ); }
#line 4967 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 381: /* function: "identifier" '(' ')'  */
#line 1202 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                        { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4973 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 382: /* function: TOK_MIN '(' expr ',' expr ')'  */
#line 1203 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { TRACK_BOUNDS ( yyval, yyvsp[-5], yyvsp[0] ); }
#line 4979 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 383: /* function: TOK_MAX '(' expr ',' expr ')'  */
#line 1204 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { TRACK_BOUNDS ( yyval, yyvsp[-5], yyvsp[0] ); }
#line 4985 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 384: /* function: TOK_WEIGHT '(' ')'  */
#line 1205 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 4991 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 385: /* function: json_aggr '(' expr TOK_FOR ident TOK_IN json_field ')'  */
#line 1206 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                                 { TRACK_BOUNDS ( yyval, yyvsp[-7], yyvsp[0] ); }
#line 4997 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 386: /* function: TOK_REMAP '(' expr ',' expr ',' '(' arglist ')' ',' '(' arglist ')' ')'  */
#line 1207 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                                                  { TRACK_BOUNDS ( yyval, yyvsp[-13], yyvsp[0] ); }
#line 5003 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 387: /* function: TOK_RAND '(' ')'  */
#line 1208 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                        { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 5009 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 388: /* function: TOK_RAND '(' arglist ')'  */
#line 1209 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-3], yyvsp[0] ); }
#line 5015 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 389: /* function: TOK_REGEX '(' arglist ')'  */
#line 1210 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-3], yyvsp[0] ); }
#line 5021 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 398: /* consthash: hash_key '=' hash_val  */
#line 1231 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 5027 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 399: /* consthash: consthash ',' hash_key '=' hash_val  */
#line 1232 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-4], yyvsp[0] ); }
#line 5033 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 408: /* like_filter: TOK_LIKE "string"  */
#line 1255 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { pParser->m_pStmt->m_sStringParam = pParser->ToStringUnescape (yyvsp[0] ); }
#line 5039 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 409: /* show_what: TOK_WARNINGS  */
#line 1259 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { pParser->m_pStmt->m_eStmt = STMT_SHOW_WARNINGS; }
#line 5045 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 410: /* show_what: TOK_STATUS like_filter  */
#line 1260 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { pParser->m_pStmt->m_eStmt = STMT_SHOW_STATUS; }
#line 5051 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 411: /* show_what: TOK_META like_filter  */
#line 1261 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { pParser->m_pStmt->m_eStmt = STMT_SHOW_META; }
#line 5057 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 412: /* show_what: TOK_AGENT TOK_STATUS like_filter  */
#line 1262 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { pParser->m_pStmt->m_eStmt = STMT_SHOW_AGENT_STATUS; }
#line 5063 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 413: /* show_what: TOK_PROFILE  */
#line 1263 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { pParser->m_pStmt->m_eStmt = STMT_SHOW_PROFILE; }
#line 5069 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 414: /* show_what: TOK_PLAN  */
#line 1264 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { pParser->m_pStmt->m_eStmt = STMT_SHOW_PLAN; }
#line 5075 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 415: /* show_what: TOK_PLUGINS  */
#line 1265 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { pParser->m_pStmt->m_eStmt = STMT_SHOW_PLUGINS; }
#line 5081 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 416: /* show_what: TOK_THREADS  */
#line 1266 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { pParser->m_pStmt->m_eStmt = STMT_SHOW_THREADS; }
#line 5087 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 417: /* show_what: TOK_CREATE TOK_TABLE identidx  */
#line 1268 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_eStmt = STMT_SHOW_CREATE_TABLE;
			pParser->ToString ( pParser->m_pStmt->m_sIndex, yyvsp[0] );
		}
#line 5096 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 418: /* show_what: TOK_AGENT "string" TOK_STATUS like_filter  */
#line 1273 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_eStmt = STMT_SHOW_AGENT_STATUS;
			pParser->m_pStmt->m_sIndex = pParser->ToStringUnescape ( yyvsp[-2] );
		}
#line 5105 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 419: /* show_what: TOK_AGENT only_one_index TOK_STATUS like_filter  */
#line 1278 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_eStmt = STMT_SHOW_AGENT_STATUS;
			pParser->ToString ( pParser->m_pStmt->m_sIndex, yyvsp[-2] );
		}
#line 5114 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 420: /* show_what: index_or_table one_index_opt_chunk TOK_STATUS like_filter  */
#line 1283 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_eStmt = STMT_SHOW_INDEX_STATUS;
			pParser->ToString ( pParser->m_pStmt->m_sIndex, yyvsp[-2] );
		}
#line 5123 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 421: /* show_what: index_or_table one_index_opt_chunk TOK_SETTINGS  */
#line 1288 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_eStmt = STMT_SHOW_INDEX_SETTINGS;
			pParser->ToString ( pParser->m_pStmt->m_sIndex, yyvsp[-1] );
		}
#line 5132 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 422: /* show_what: index_or_table TOK_STATUS like_filter  */
#line 1293 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_eStmt = STMT_SHOW_INDEX_STATUS;
			pParser->m_pStmt->m_sIndex = pParser->m_pStmt->m_sStringParam;
		}
#line 5141 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 423: /* show_what: TOK_COLLATION  */
#line 1298 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
       		pParser->m_pStmt->m_eStmt = STMT_SHOW_COLLATION;
		}
#line 5149 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 424: /* show_what: TOK_CHARACTER TOK_SET  */
#line 1302 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_eStmt = STMT_SHOW_CHARACTER_SET;
		}
#line 5157 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 425: /* show_what: TOK_TABLES like_filter  */
#line 1306 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_eStmt = STMT_SHOW_TABLES;
		}
#line 5165 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 426: /* show_what: TOK_DATABASES like_filter  */
#line 1310 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_eStmt = STMT_SHOW_DATABASES;
		}
#line 5173 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 427: /* show_what: opt_scope TOK_VARIABLES opt_show_variables_where_or_like  */
#line 1314 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
      		pParser->m_pStmt->m_eStmt = STMT_SHOW_VARIABLES;
		}
#line 5181 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 430: /* set_stmt: TOK_SET ident_set '=' bool_or_integer_value  */
#line 1328 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->SetStatement ( yyvsp[-2], SET_LOCAL );
			pParser->m_pStmt->m_iSetValue = yyvsp[0].m_iValue;
		}
#line 5190 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 431: /* set_stmt: TOK_SET ident_set '=' set_string_value  */
#line 1333 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->SetStatement ( yyvsp[-2], SET_LOCAL );
			pParser->ToString ( pParser->m_pStmt->m_sSetValue, yyvsp[0] );
		}
#line 5199 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 432: /* set_stmt: TOK_SET ident_set '=' TOK_NULL  */
#line 1338 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->SetStatement ( yyvsp[-2], SET_LOCAL );
//			pParser->m_pStmt->m_bSetNull = true;
		}
#line 5208 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 433: /* set_stmt: TOK_SET TOK_NAMES set_value opt_collate  */
#line 1342 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                  { pParser->m_pStmt->m_eStmt = STMT_DUMMY; }
#line 5214 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 434: /* set_stmt: TOK_SET sysvar '=' set_value  */
#line 1343 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { pParser->m_pStmt->m_eStmt = STMT_DUMMY; }
#line 5220 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 435: /* set_stmt: TOK_SET TOK_CHARACTER TOK_SET set_value  */
#line 1344 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                  { pParser->m_pStmt->m_eStmt = STMT_DUMMY; }
#line 5226 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 438: /* set_global_stmt: TOK_SET TOK_GLOBAL "@uservar" '=' '(' const_list ')'  */
#line 1354 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->SetStatement ( yyvsp[-4], SET_GLOBAL_UVAR );
			pParser->m_pStmt->m_dSetValues = *yyvsp[-1].m_pValues;
		}
#line 5235 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 439: /* set_global_stmt: TOK_SET TOK_GLOBAL ident_set '=' set_string_value  */
#line 1359 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->SetStatement ( yyvsp[-2], SET_GLOBAL_SVAR );
			pParser->ToString ( pParser->m_pStmt->m_sSetValue, yyvsp[0] ).Unquote();
		}
#line 5244 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 440: /* set_global_stmt: TOK_SET TOK_GLOBAL ident_set '=' const_int  */
#line 1364 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->SetStatement ( yyvsp[-2], SET_GLOBAL_SVAR );
			pParser->m_pStmt->m_iSetValue = yyvsp[0].m_iValue;
		}
#line 5253 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 441: /* set_global_stmt: TOK_SET TOK_INDEX identidx TOK_GLOBAL "@uservar" '=' '(' const_list ')'  */
#line 1369 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->SetStatement ( yyvsp[-4], SET_INDEX_UVAR );
			pParser->m_pStmt->m_dSetValues = *yyvsp[-1].m_pValues;
			pParser->ToString ( pParser->m_pStmt->m_sIndex, yyvsp[-6] );
		}
#line 5263 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 442: /* set_global_stmt: TOK_SET TOK_CLUSTER ident TOK_GLOBAL "string" '=' set_string_value  */
#line 1375 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->SetStatement ( yyvsp[-2], SET_CLUSTER_UVAR );
			pParser->ToString ( pParser->m_pStmt->m_sIndex, yyvsp[-4] );
			pParser->ToString ( pParser->m_pStmt->m_sSetName, yyvsp[-2] ).Unquote();
			pParser->ToString ( pParser->m_pStmt->m_sSetValue, yyvsp[0] ).Unquote();
		}
#line 5274 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 443: /* set_global_stmt: TOK_SET TOK_CLUSTER ident TOK_GLOBAL "string" '=' const_int  */
#line 1382 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->SetStatement ( yyvsp[-2], SET_CLUSTER_UVAR );
			pParser->ToString ( pParser->m_pStmt->m_sIndex, yyvsp[-4] );
			pParser->ToString ( pParser->m_pStmt->m_sSetName, yyvsp[-2] ).Unquote();
			pParser->m_pStmt->m_sSetValue.SetSprintf ( INT64_FMT, yyvsp[0].m_iValue );
		}
#line 5285 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 446: /* bool_or_integer_value: TOK_TRUE  */
#line 1396 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { yyval.m_iValue = 1; }
#line 5291 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 447: /* bool_or_integer_value: TOK_FALSE  */
#line 1397 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { yyval.m_iValue = 0; }
#line 5297 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 448: /* bool_or_integer_value: const_int  */
#line 1398 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { yyval.m_iValue = yyvsp[0].m_iValue; }
#line 5303 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 456: /* transact_op: TOK_COMMIT  */
#line 1418 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { pParser->m_pStmt->m_eStmt = STMT_COMMIT; }
#line 5309 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 457: /* transact_op: TOK_ROLLBACK  */
#line 1419 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { pParser->m_pStmt->m_eStmt = STMT_ROLLBACK; }
#line 5315 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 458: /* transact_op: start_transaction  */
#line 1420 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { pParser->m_pStmt->m_eStmt = STMT_BEGIN; }
#line 5321 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 462: /* insert_or_replace: TOK_INSERT  */
#line 1435 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                { pParser->m_pStmt->m_eStmt = STMT_INSERT; }
#line 5327 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 463: /* insert_or_replace: TOK_REPLACE  */
#line 1436 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                        { pParser->m_pStmt->m_eStmt = STMT_REPLACE; }
#line 5333 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 467: /* column_list: column_ident  */
#line 1449 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                        { if ( !pParser->AddSchemaItem ( &yyvsp[0] ) ) { yyerror ( pParser, "unknown field" ); YYERROR; } }
#line 5339 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 468: /* column_list: column_list ',' column_ident  */
#line 1450 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { if ( !pParser->AddSchemaItem ( &yyvsp[0] ) ) { yyerror ( pParser, "unknown field" ); YYERROR; } }
#line 5345 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 471: /* insert_row: '(' insert_vals_list ')'  */
#line 1459 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { if ( !pParser->m_pStmt->CheckInsertIntegrity() ) { yyerror ( pParser, "wrong number of values here" ); YYERROR; } }
#line 5351 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 472: /* insert_vals_list: insert_val  */
#line 1463 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { pParser->AddInsval ( pParser->m_pStmt->m_dInsertValues, yyvsp[0] ); }
#line 5357 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 473: /* insert_vals_list: insert_vals_list ',' insert_val  */
#line 1464 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { pParser->AddInsval ( pParser->m_pStmt->m_dInsertValues, yyvsp[0] ); }
#line 5363 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 474: /* insert_val: const_int  */
#line 1468 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { yyval.m_iType = TOK_CONST_INT; yyval.m_iValue = yyvsp[0].m_iValue; }
#line 5369 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 475: /* insert_val: const_float  */
#line 1469 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { yyval.m_iType = TOK_CONST_FLOAT; yyval.m_fValue = yyvsp[0].m_fValue; }
#line 5375 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 476: /* insert_val: "string"  */
#line 1470 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { yyval.m_iType = TOK_QUOTED_STRING; yyval.m_iStart = yyvsp[0].m_iStart; yyval.m_iEnd = yyvsp[0].m_iEnd; }
#line 5381 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 477: /* insert_val: '(' const_list ')'  */
#line 1471 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { yyval.m_iType = TOK_CONST_MVA; yyval.m_pValues = yyvsp[-1].m_pValues; }
#line 5387 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 478: /* insert_val: '(' ')'  */
#line 1472 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                        { yyval.m_iType = TOK_CONST_MVA; }
#line 5393 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 479: /* $@2: %empty  */
#line 1478 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                   { pParser->m_pStmt->m_eStmt = STMT_DELETE; }
#line 5399 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 480: /* delete_from: TOK_DELETE $@2 TOK_FROM one_index_opt_chunk where_clause opt_option_clause  */
#line 1480 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                        {
				pParser->GenericStatement ( &yyvsp[-2] );
			}
#line 5407 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 481: /* call_proc: TOK_CALL ident '(' call_args_list opt_call_opts_list ')'  */
#line 1489 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_eStmt = STMT_CALL;
			pParser->ToString ( pParser->m_pStmt->m_sCallProc, yyvsp[-4] );
		}
#line 5416 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 482: /* call_args_list: call_arg  */
#line 1497 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->AddInsval ( pParser->m_pStmt->m_dInsertValues, yyvsp[0] );
		}
#line 5424 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 483: /* call_args_list: call_args_list ',' call_arg  */
#line 1501 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->AddInsval ( pParser->m_pStmt->m_dInsertValues, yyvsp[0] );
		}
#line 5432 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 485: /* call_arg: '(' const_string_list ')'  */
#line 1509 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			yyval.m_iType = TOK_CONST_STRINGS;
		}
#line 5440 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 486: /* const_string_list: "string"  */
#line 1516 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			// FIXME? for now, one such array per CALL statement, tops
			if ( pParser->m_pStmt->m_dCallStrings.GetLength() )
			{
				yyerror ( pParser, "unexpected constant string list" );
				YYERROR;
			}
			pParser->m_pStmt->m_dCallStrings.Add() = pParser->ToStringUnescape ( yyvsp[0] );
		}
#line 5454 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 487: /* const_string_list: const_string_list ',' "string"  */
#line 1526 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_dCallStrings.Add() = pParser->ToStringUnescape ( yyvsp[0] );
		}
#line 5462 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 490: /* call_opts_list: call_opt  */
#line 1538 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			assert ( pParser->m_pStmt->m_dCallOptNames.GetLength()==1 );
			assert ( pParser->m_pStmt->m_dCallOptValues.GetLength()==1 );
		}
#line 5471 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 492: /* call_opt: insert_val opt_as call_opt_name  */
#line 1547 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->ToString ( pParser->m_pStmt->m_dCallOptNames.Add(), yyvsp[0] );
			pParser->AddInsval ( pParser->m_pStmt->m_dCallOptValues, yyvsp[-2] );
		}
#line 5480 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 497: /* describe: describe_tok one_index_opt_subindex describe_opt like_filter  */
#line 1567 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_eStmt = STMT_DESCRIBE;
		}
#line 5488 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 499: /* describe_opt: TOK_TABLE  */
#line 1575 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_iIntParam = TOK_TABLE; // just a flag that 'TOK_TABLE' is in use
		}
#line 5496 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 502: /* $@3: %empty  */
#line 1589 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                   { pParser->m_pStmt->m_eStmt = STMT_UPDATE; }
#line 5502 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 503: /* update: TOK_UPDATE $@3 one_index_opt_chunk TOK_SET update_items_list where_clause opt_option_clause opt_hint_clause  */
#line 1591 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                        {
				pParser->GenericStatement ( &yyvsp[-5] );
			}
#line 5510 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 506: /* update_item: ident '=' const_int  */
#line 1603 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			// it is performance-critical to forcibly inline this
			pParser->m_pStmt->m_pUpdate->m_dPool.Add ( (DWORD)yyvsp[0].m_iValue );
			DWORD uHi = (DWORD)( yyvsp[0].m_iValue>>32 );
			if ( uHi )
			{
				pParser->m_pStmt->m_pUpdate->m_dPool.Add ( uHi );
				pParser->AddUpdatedAttr ( yyvsp[-2], SPH_ATTR_BIGINT );
			} else
			{
				pParser->AddUpdatedAttr ( yyvsp[-2], SPH_ATTR_INTEGER );
			}
		}
#line 5528 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 507: /* update_item: ident '=' const_float  */
#line 1617 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			// it is performance-critical to forcibly inline this
			pParser->m_pStmt->m_pUpdate->m_dPool.Add ( sphF2DW ( yyvsp[0].m_fValue ) );
			pParser->AddUpdatedAttr ( yyvsp[-2], SPH_ATTR_FLOAT );
		}
#line 5538 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 508: /* update_item: ident '=' '(' const_list ')'  */
#line 1623 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->UpdateMVAAttr ( yyvsp[-4], yyvsp[-1] );
		}
#line 5546 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 509: /* update_item: ident '=' '(' ')'  */
#line 1627 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			SqlNode_t tNoValues;
			pParser->UpdateMVAAttr ( yyvsp[-3], tNoValues );
		}
#line 5555 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 510: /* update_item: json_expr '=' const_int  */
#line 1632 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			// it is performance-critical to forcibly inline this
			pParser->m_pStmt->m_pUpdate->m_dPool.Add ( (DWORD)yyvsp[0].m_iValue );
			DWORD uHi = (DWORD)( yyvsp[0].m_iValue>>32 );
			if ( uHi )
			{
				pParser->m_pStmt->m_pUpdate->m_dPool.Add ( uHi );
				pParser->AddUpdatedAttr ( yyvsp[-2], SPH_ATTR_BIGINT );
			} else
			{
				pParser->AddUpdatedAttr ( yyvsp[-2], SPH_ATTR_INTEGER );
			}
		}
#line 5573 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 511: /* update_item: json_expr '=' const_float  */
#line 1646 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			// it is performance-critical to forcibly inline this
			pParser->m_pStmt->m_pUpdate->m_dPool.Add ( sphF2DW ( yyvsp[0].m_fValue ) );
			pParser->AddUpdatedAttr ( yyvsp[-2], SPH_ATTR_FLOAT );
		}
#line 5583 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 512: /* update_item: ident '=' "string"  */
#line 1652 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->UpdateStringAttr ( yyvsp[-2], yyvsp[0] );
		}
#line 5591 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 519: /* set_transaction: TOK_SET opt_scope TOK_TRANSACTION TOK_ISOLATION TOK_LEVEL isolation_level  */
#line 1679 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_eStmt = STMT_DUMMY;
		}
#line 5599 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 521: /* opt_scope: TOK_GLOBAL  */
#line 1687 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_iIntParam = 0;
		}
#line 5607 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 522: /* opt_scope: TOK_SESSION  */
#line 1691 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
    		pParser->m_pStmt->m_iIntParam = 1;
    	}
#line 5615 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 527: /* attach_index: TOK_ATTACH TOK_INDEX identidx TOK_TO TOK_RTINDEX identidx opt_with_truncate  */
#line 1707 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_ATTACH_INDEX;
			pParser->ToString ( tStmt.m_sIndex, yyvsp[-4] );
			pParser->ToString ( tStmt.m_sStringParam, yyvsp[-1] );
		}
#line 5626 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 529: /* opt_with_truncate: TOK_WITH TOK_TRUNCATE  */
#line 1718 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_iIntParam = 1;
		}
#line 5634 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 530: /* flush_rtindex: TOK_FLUSH TOK_RTINDEX identidx  */
#line 1727 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_FLUSH_RTINDEX;
			pParser->ToString ( tStmt.m_sIndex, yyvsp[0] );
		}
#line 5644 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 531: /* flush_ramchunk: TOK_FLUSH TOK_RAMCHUNK identidx  */
#line 1736 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_FLUSH_RAMCHUNK;
			pParser->ToString ( tStmt.m_sIndex, yyvsp[0] );
		}
#line 5654 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 532: /* flush_index: TOK_FLUSH TOK_ATTRIBUTES  */
#line 1745 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_FLUSH_INDEX;
		}
#line 5663 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 533: /* flush_hostnames: TOK_FLUSH TOK_HOSTNAMES  */
#line 1753 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_FLUSH_HOSTNAMES;
		}
#line 5672 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 534: /* flush_logs: TOK_FLUSH TOK_LOGS  */
#line 1761 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_FLUSH_LOGS;
		}
#line 5681 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 535: /* select_sysvar: TOK_SELECT sysvar_list opt_limit_clause  */
#line 1771 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_eStmt = STMT_SELECT_SYSVAR;
			pParser->ToString ( pParser->m_pStmt->m_tQuery.m_sQuery, yyvsp[-1] );
		}
#line 5690 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 539: /* sysvar_name: sysvar  */
#line 1787 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
               { pParser->AddItem ( &yyvsp[0] ); }
#line 5696 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 540: /* select_dual: TOK_SELECT expr  */
#line 1792 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_eStmt = STMT_SELECT_DUAL;
			pParser->ToString ( pParser->m_pStmt->m_tQuery.m_sQuery, yyvsp[0] );
		}
#line 5705 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 541: /* truncate: TOK_TRUNCATE rtindex only_one_index opt_with_reconfigure  */
#line 1802 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_TRUNCATE_RTINDEX;
		}
#line 5714 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 545: /* opt_with_reconfigure: TOK_WITH TOK_RECONFIGURE  */
#line 1816 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_iIntParam = 1;
		}
#line 5722 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 546: /* $@4: %empty  */
#line 1824 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                      { pParser->m_pStmt->m_eStmt = STMT_OPTIMIZE_INDEX; }
#line 5728 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 547: /* optimize_index: TOK_OPTIMIZE $@4 TOK_INDEX identidx opt_option_clause  */
#line 1826 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                        {
				pParser->ToString ( pParser->m_pStmt->m_sIndex, yyvsp[-1] );
			}
#line 5736 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 548: /* reload_plugins: TOK_RELOAD TOK_PLUGINS TOK_FROM TOK_SONAME "string"  */
#line 1835 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			SqlStmt_t & s = *pParser->m_pStmt;
			s.m_eStmt = STMT_RELOAD_PLUGINS;
			s.m_sUdfLib = pParser->ToStringUnescape ( yyvsp[0] );
		}
#line 5746 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 551: /* json_expr: ident subscript  */
#line 1850 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { yyval = yyvsp[-1]; yyval.m_iEnd = yyvsp[0].m_iEnd; }
#line 5752 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 553: /* subscript: subscript subkey  */
#line 1854 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { yyval = yyvsp[-1]; yyval.m_iEnd = yyvsp[0].m_iEnd; }
#line 5758 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 557: /* subkey: '[' expr ']'  */
#line 1861 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { yyval = yyvsp[-2]; yyval.m_iEnd = yyvsp[0].m_iEnd; }
#line 5764 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 558: /* subkey: '[' "string" ']'  */
#line 1862 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { yyval = yyvsp[-2]; yyval.m_iEnd = yyvsp[0].m_iEnd; }
#line 5770 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 559: /* streq: expr '=' strval  */
#line 1866 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 5776 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 560: /* streq: strval '=' expr  */
#line 1867 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                { TRACK_BOUNDS ( yyval, yyvsp[-2], yyvsp[0] ); }
#line 5782 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 563: /* opt_distinct_item: TOK_DISTINCT  */
#line 1878 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                                        { pParser->AddDistinct ( nullptr ); }
#line 5788 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 564: /* opt_distinct_item: TOK_DISTINCT ident  */
#line 1879 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                                                                { pParser->AddDistinct ( &yyvsp[0] ); }
#line 5794 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 567: /* facet_by: TOK_BY  */
#line 1889 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pQuery->m_sFacetBy = pParser->m_pQuery->m_sGroupBy;
			pParser->m_pQuery->m_sGroupBy = "";
			pParser->AddCount ();
		}
#line 5804 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 569: /* facet_expr: expr  */
#line 1902 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->AddItem ( &yyvsp[0] );
			pParser->AddGroupBy ( yyvsp[0] );
		}
#line 5813 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 572: /* facet_stmt: TOK_FACET facet_items_list opt_facet_by_items_list opt_distinct_item opt_order_clause opt_limit_clause  */
#line 1915 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_eStmt = STMT_FACET;
			if ( pParser->m_pQuery->m_sFacetBy.IsEmpty() )
			{
				pParser->m_pQuery->m_sFacetBy = pParser->m_pQuery->m_sGroupBy;
				pParser->AddCount ();
			}
			if ( !pParser->MaybeAddFacetDistinct() )
				YYERROR;
		}
#line 5828 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 574: /* opt_reload_index_from: TOK_FROM "string"  */
#line 1930 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_sStringParam = pParser->ToStringUnescape ( yyvsp[0] );
		}
#line 5836 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 575: /* reload_index: TOK_RELOAD TOK_INDEX identidx opt_reload_index_from  */
#line 1937 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			pParser->m_pStmt->m_eStmt = STMT_RELOAD_INDEX;
			pParser->ToString ( pParser->m_pStmt->m_sIndex, yyvsp[-1]);
		}
#line 5845 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 576: /* reload_indexes: TOK_RELOAD TOK_INDEXES  */
#line 1945 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_RELOAD_INDEXES;
		}
#line 5854 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 577: /* sysfilters: TOK_SYSFILTERS filter_expr  */
#line 1953 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_SYSFILTERS;
		}
#line 5863 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 578: /* delete_cluster: TOK_DELETE TOK_CLUSTER ident  */
#line 1961 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_CLUSTER_DELETE;
			pParser->ToString ( tStmt.m_sIndex, yyvsp[0] );
		}
#line 5873 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 579: /* $@5: %empty  */
#line 1969 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                      { pParser->m_pStmt->m_eStmt = STMT_EXPLAIN; }
#line 5879 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;

  case 580: /* explain_query: TOK_EXPLAIN $@5 ident ident "string" opt_option_clause  */
#line 1971 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"
                        {
				SqlStmt_t & tStmt = *pParser->m_pStmt;
				pParser->ToString ( tStmt.m_sCallProc, yyvsp[-3] );
				pParser->ToString ( tStmt.m_sIndex, yyvsp[-2] );
				pParser->m_pQuery->m_sQuery = pParser->ToStringUnescape ( yyvsp[-1] );
			}
#line 5890 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"
    break;


#line 5894 "/usr/src/RPM/BUILD/manticore-4.0.2/config/bissphinxql.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (pParser, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, pParser);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, pParser);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (pParser, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, pParser);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, pParser);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 1979 "/usr/src/RPM/BUILD/manticore-4.0.2/src/sphinxql.y"


#if _WIN32
#pragma warning(pop)
#endif
